using Illusion.Extensions;
using System;

namespace ADV.Commands.Chara
{
    public class Coordinate : CommandBase
    {
        private int no;

        private ChaFileDefine.CoordinateType type;

        public override string[] ArgsLabel
        {
            get
            {
                return new string[2]
                {
                    "No",
                    "Type"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[2]
                {
                    "0",
                    ChaFileDefine.CoordinateType.School01.ToString()
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            no = int.Parse(args[num++]);
            string self = args[num++];
            int num2 = (int)(type = (ChaFileDefine.CoordinateType)self.Check(true, Enum.GetNames(typeof(ChaFileDefine.CoordinateType))));
            scenario.commandController.GetChara(no).chaCtrl.ChangeCoordinateTypeAndReload(type);
        }
    }
}
