using Manager;
using UnityEngine;

namespace ActionGame
{
    public class PreviewDataComponent : MonoBehaviour
    {
        public ChaFileControl chaFile
        {
            get;
            private set;
        }

        public void SetChaFile(ChaFileControl chaFile)
        {
            this.chaFile = chaFile;
        }

        public bool SetInfoCard(StudentCardControlComponent card)
        {
            if (chaFile != null)
            {
                SaveData saveData = Singleton<Game>.Instance.saveData;
                card.SetCharaInfo(chaFile, saveData.emblemID, saveData.accademyName, string.Empty);
                return true;
            }
            card.Clear(Singleton<Game>.Instance.saveData.accademyName);
            return false;
        }
    }
}
