using Illusion.CustomAttributes;
using System.Collections.Generic;
using UnityEngine;

namespace Illusion.Component
{
    public class ScreenShot : MonoBehaviour
    {
        [Button("Capture", "キャプチャー", new object[]
        {
            ""
        })]
        public int excuteCapture;

        public int capRate = 1;

        public Texture texCapMark;

        public List<ScreenShotCamera> ssCamList = new List<ScreenShotCamera>();

        public void Capture(string path = null)
        {
            if (path.IsNullOrEmpty())
            {
                path = Game.Utils.ScreenShot.Path;
            }
            StartCoroutine(Game.Utils.ScreenShot.CaptureGSS(ssCamList, path, texCapMark, capRate));
        }
    }
}
