using Manager;
using UnityEngine;

public static class InitAddComponent
{
    public static void AddComponents(GameObject go)
    {
        go.AddComponent<Manager.Sound>();
        go.AddComponent<Voice>();
        go.AddComponent<Manager.Config>();
        go.AddComponent<Scene>();
        if (!Game.IsStudio)
            go.AddComponent<Game>();
        go.AddComponent<Character>();
        if (!Game.IsStudio)
        {
            go.AddComponent<Communication>();
            go.AddComponent<PlayerAction>();
        }
    }
}
