using Illusion.Extensions;
using Manager;
using System.Collections.Generic;
using UnityEngine;

public class MobAutoHideComponent : MonoBehaviour
{
    private Transform[] trfChild;

    private void Start()
    {
        int childCount = transform.childCount;
        trfChild = new Transform[childCount];
        for (int i = 0; i < childCount; i++)
            trfChild[i] = transform.GetChild(i);
    }

    private void Update()
    {
        if (Singleton<Character>.IsInstance())
        {
            bool flag = false;
            foreach (KeyValuePair<int, ChaControl> item in Singleton<Character>.Instance.dictEntryChara)
                if (!(null == item.Value))
                    flag |= item.Value.hiPoly;
            Transform[] array = trfChild;
            foreach (Transform transform in array)
                transform.gameObject.SetActiveIfDifferent(!flag);
        }
    }
}
