using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Category("GameObject")]
    [Obsolete("Use Get Property instead")]
    public class GetGameObjectPosition : ActionTask<Transform>
    {
        [BlackboardOnly]
        public BBParameter<Vector3> saveAs;

        protected override string info
        {
            get
            {
                return "Get " + agentInfo + " position as " + saveAs;
            }
        }

        protected override void OnExecute()
        {
            saveAs.value = agent.position;
            EndAction();
        }
    }
}
