using NodeCanvas.Framework;
using NodeCanvas.StateMachines;
using ParadoxNotion.Design;

namespace NodeCanvas.Tasks.Actions
{
    [Description("Switch the entire FSM of FSMTreeOwner")]
    [Category("✫ Utility")]
    public class SwitchFSM : ActionTask<FSMOwner>
    {
        [RequiredField]
        public BBParameter<FSM> fsm;

        protected override string info
        {
            get
            {
                return string.Format("Switch FSM {0}", fsm);
            }
        }

        protected override void OnExecute()
        {
            agent.SwitchBehaviour(fsm.value);
            EndAction();
        }
    }
}
