using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections;

namespace NodeCanvas.Tasks.Conditions
{
    [Category("✫ Blackboard/Lists")]
    public class ListIsEmpty : ConditionTask
    {
        [BlackboardOnly]
        [RequiredField]
        public BBParameter<IList> targetList;

        protected override string info
        {
            get
            {
                return string.Format("{0} Is Empty", targetList);
            }
        }

        protected override bool OnCheck()
        {
            return targetList.value.Count == 0;
        }
    }
}
