using Illusion.Extensions;
using UnityEngine;
using UnityEngine.UI;

namespace StaffRoom
{
    public class StaffRoomInfoComponent : MonoBehaviour
    {
        public FileInfo info;

        public Toggle tgl;

        public RawImage imgThumb;

        public void Disable(bool disable)
        {
            if ((bool)tgl)
            {
                tgl.interactable = !disable;
            }
            if ((bool)imgThumb)
            {
                imgThumb.color = Color.gray;
            }
        }

        public void Disvisible(bool disvisible)
        {
            gameObject.SetActiveIfDifferent(!disvisible);
        }
    }
}
