using UnityEngine;

public class UI_NoControlCamera_Old : MonoBehaviour
{
    public RectTransform rtCanvas;

    private CameraControl camCtrl;

    private void Start()
    {
        SearchCanvas();
        if (null == camCtrl && Camera.main)
        {
            camCtrl = Camera.main.GetComponent<CameraControl>();
        }
    }

    private void SearchCanvas()
    {
        GameObject gameObject = base.gameObject;
        while (true)
        {
            Canvas component = gameObject.GetComponent<Canvas>();
            if ((bool)component)
            {
                break;
            }
            if (null == gameObject.transform.parent)
            {
                return;
            }
            gameObject = gameObject.transform.parent.gameObject;
        }
        rtCanvas = gameObject.transform as RectTransform;
    }

    public void Update()
    {
        if (Input.GetMouseButtonUp(0) || Input.GetMouseButtonUp(1))
        {
            if ((bool)camCtrl)
            {
                camCtrl.NoCtrlCondition = () => false;
            }
        }
        else
        {
            if (!Input.GetMouseButtonDown(0) && !Input.GetMouseButtonDown(1) || null == rtCanvas)
            {
                return;
            }
            RectTransform rectTransform = transform as RectTransform;
            Vector3 mousePosition = Input.mousePosition;
            float x = mousePosition.x;
            Vector3 mousePosition2 = Input.mousePosition;
            float y = mousePosition2.y;
            Vector3 position = rectTransform.position;
            if (!(position.x <= x))
            {
                return;
            }
            Vector3 position2 = rectTransform.position;
            float x2 = position2.x;
            Vector2 sizeDelta = rectTransform.sizeDelta;
            float x3 = sizeDelta.x;
            Vector3 localScale = rtCanvas.localScale;
            if (!(x <= x2 + x3 * localScale.x))
            {
                return;
            }
            Vector3 position3 = rectTransform.position;
            if (position3.y >= y)
            {
                Vector3 position4 = rectTransform.position;
                float y2 = position4.y;
                Vector2 sizeDelta2 = rectTransform.sizeDelta;
                float y3 = sizeDelta2.y;
                Vector3 localScale2 = rtCanvas.localScale;
                if (y >= y2 - y3 * localScale2.y && camCtrl)
                {
                    camCtrl.NoCtrlCondition = () => true;
                }
            }
        }
    }
}
