namespace ADV.Commands.Base
{
    public class Close : CommandBase
    {
        public override string[] ArgsLabel
        {
            get
            {
                return null;
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return null;
            }
        }

        public override void Do()
        {
            base.Do();
            Proc();
        }

        private void Proc()
        {
            bool isADVActionActive = Program.isADVActionActive;
            if (scenario.advScene != null)
            {
                scenario.advScene.Release();
            }
            else
            {
                scenario.gameObject.SetActive(false);
            }
            if (!isADVActionActive && scenario.advScene != null)
            {
                Singleton<Manager.Scene>.Instance.UnLoad();
            }
        }
    }
}
