using System.Linq;

namespace ADV.Commands.Camera
{
    public class Change : Base
    {
        public override string[] ArgsLabel
        {
            get
            {
                return new string[1]
                {
                    "Name"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return null;
            }
        }

        public override void Do()
        {
            base.Do();
            UnityEngine.Camera camera = UnityEngine.Object.FindObjectsOfType<UnityEngine.Camera>().FirstOrDefault(cam => cam.name == args[0]);
            if (camera != null)
            {
                scenario.AdvCamera = camera;
            }
        }
    }
}
