using System.Collections.Generic;
using System.Linq;

namespace ADV.Commands.Chara
{
    public class Motion : ADV.Commands.Base.Motion
    {
        public override void Do()
        {
            List<Data> list = Convert(ref args, scenario, ArgsLabel.Length);
            if (list.Any())
            {
                scenario.CrossFadeStart();
            }
            list.ForEach(delegate (Data p)
            {
                p.Play(scenario);
            });
        }
    }
}
