namespace ADV
{
    public enum Command
    {
        None,
        VAR,
        RandomVar,
        Calc,
        Clamp,
        Min,
        Max,
        Lerp,
        LerpAngle,
        InverseLerp,
        LerpV3,
        LerpAngleV3,
        Tag,
        Format,
        IF,
        Switch,
        Text,
        Voice,
        Motion,
        Expression,
        ExpressionIcon,
        Open,
        Close,
        Jump,
        Choice,
        Wait,
        TextClear,
        FontColor,
        WindowActive,
        WindowImage,
        Scene,
        Regulate,
        Replace,
        Reset,
        Vector,
        NullLoad,
        NullRelease,
        NullSet,
        BGLoad,
        BGRelease,
        BGVisible,
        InfoAudioEco,
        InfoAnimePlay,
        Fade,
        SceneFade,
        SceneFadeRegulate,
        FadeWait,
        FilterImageLoad,
        FilterImageRelease,
        FadeSet,
        FilterSet,
        Filter,
        ImageLoad,
        ImageRelease,
        EjaculationEffect,
        EcstacyEffect,
        EcstacySyncEffect,
        CrossFade,
        BlurEffect,
        DOFTarget,
        SepiaEffect,
        CameraActive,
        CameraAspect,
        CameraChange,
        CameraDirectionAdd,
        CameraDirectionSet,
        CameraLerpNullMove,
        CameraLerpNullSet,
        CameraLerpAdd,
        CameraLerpSet,
        CameraLerpAnimationAdd,
        CameraLerpAnimationSet,
        CameraLerpTargetAdd,
        CameraLerpTargetSet,
        CameraPositionAdd,
        CameraPositionSet,
        CameraRotationAdd,
        CameraRotationSet,
        CameraDefault,
        CameraParent,
        CameraNull,
        CameraTarget,
        CameraTargetFront,
        CameraTargetCharacter,
        CameraReset,
        CameraLock,
        CameraGetFov,
        CameraSetFov,
        BGMPlay,
        BGMStop,
        EnvPlay,
        EnvStop,
        SE2DPlay,
        SE2DStop,
        SE3DPlay,
        SE3DStop,
        CharaCreate,
        CharaFixCreate,
        CharaMobCreate,
        CharaDelete,
        CharaStand,
        CharaStandFind,
        CharaPositionAdd,
        CharaPositionSet,
        CharaPositionLocalAdd,
        CharaPositionLocalSet,
        CharaMotion,
        CharaMotionDefault,
        CharaMotionWait,
        CharaMotionLayerWeight,
        CharaMotionSetParam,
        CharaMotionIKSetPartner,
        CharaExpression,
        CharaFixEyes,
        CharaFixMouth,
        CharaExpressionIcon,
        CharaGetShape,
        CharaCoordinate,
        CharaClothState,
        CharaSiruState,
        CharaVoicePlay,
        CharaVoiceStop,
        CharaVoiceStopAll,
        CharaVoiceWait,
        CharaVoiceWaitAll,
        CharaLookEyes,
        CharaLookEyesTarget,
        CharaLookEyesTargetChara,
        CharaLookNeck,
        CharaLookNeckTarget,
        CharaLookNeckTargetChara,
        CharaLookNeckSkip,
        CharaItemCreate,
        CharaItemDelete,
        CharaItemAnime,
        CharaItemFind,
        EventCGSetting,
        EventCGRelease,
        EventCGNext,
        MotionLoad,
        ExpLoad,
        Chara2DCreate,
        Chara2DDelete,
        Chara2DStand,
        Chara2DPositionAdd,
        Chara2DPositionSet,
        ObjectCreate,
        ObjectLoad,
        ObjectDelete,
        ObjectPosition,
        ObjectRotation,
        ObjectScale,
        ObjectParent,
        ObjectComponent,
        ObjectAnimeParam,
        MoviePlay,
        CharaActive,
        CharaVisible,
        CharaColor,
        CharaParam,
        CharaChange,
        CharaNameGet,
        CharaEvent,
        HeroineCallNameChange,
        HeroineFinCG,
        HeroineParam,
        PlayerParam,
        CycleChange,
        WeekChange,
        MapChange,
        MapUnload,
        MapVisible,
        MapObjectActive,
        DayTimeChange,
        GetGatePos,
        CameraLookAt,
        MozVisible,
        LookAtDankonAdd,
        LookAtDankonRemove,
        HMotionShakeAdd,
        HMotionShakeRemove,
        HitReaction,
        AddPosture,
        AddCollider,
        ColliderSetActive,
        AddNavMeshAgent,
        NavMeshAgentSetActive,
        BundleCheck,
        CharaPersonal,
        HNamaOK,
        HNamaNG,
        CameraShakePos,
        CameraShakeRot,
        Prob,
        Probs,
        FormatVAR,
        CharaKaraokePlay,
        CharaKaraokeStop,
        Task,
        TaskWait,
        TaskEnd,
        ParameterFile,
        Log,
        HSafeDaySet,
        HDangerDaySet,
        HeroineWeddingInfo,
        CameraLightOffset,
        CharaSetShape,
        CharaCoordinateChange,
        CharaShoesChange,
        CameraAnimeLoad,
        CameraAnimePlay,
        CameraAnimeWait,
        CameraAnimeLayerWeight,
        CameraAnimeSetParam,
        CameraAnimeRelease,
        CameraLightActive,
        CameraLightAngle,
        InfoAudio,
        CharaCreateEmpty,
        CharaCreateDummy,
        CharaFixCreateDummy,
        CharaMobCreateDummy
    }
}
