using Illusion.Extensions;
using System;
using System.Collections;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsClothes : MonoBehaviour
    {
        public ChaFileDefine.ClothesKind typeClothes;

        [SerializeField]
        private Button btnInitSetting;

        [SerializeField]
        private TextMeshProUGUI textInitBtnName;

        [SerializeField]
        private Toggle tglClothesKind;

        [SerializeField]
        private Image imgClothesKind;

        [SerializeField]
        private TextMeshProUGUI textClothesKind;

        [SerializeField]
        private CustomSelectKind customClothes;

        [SerializeField]
        private CanvasGroup cgClothesWin;

        [SerializeField]
        private Toggle tglSailor01Kind;

        [SerializeField]
        private Image imgSailor01Kind;

        [SerializeField]
        private TextMeshProUGUI textSailor01Kind;

        [SerializeField]
        private CustomSelectKind customSailor01;

        [SerializeField]
        private CanvasGroup cgSailor01Win;

        [SerializeField]
        private Toggle tglSailor02Kind;

        [SerializeField]
        private Image imgSailor02Kind;

        [SerializeField]
        private TextMeshProUGUI textSailor02Kind;

        [SerializeField]
        private CustomSelectKind customSailor02;

        [SerializeField]
        private CanvasGroup cgSailor02Win;

        [SerializeField]
        private Toggle tglSailor03Kind;

        [SerializeField]
        private Image imgSailor03Kind;

        [SerializeField]
        private TextMeshProUGUI textSailor03Kind;

        [SerializeField]
        private CustomSelectKind customSailor03;

        [SerializeField]
        private CanvasGroup cgSailor03Win;

        [SerializeField]
        private Toggle tglJacket01Kind;

        [SerializeField]
        private Image imgJacket01Kind;

        [SerializeField]
        private TextMeshProUGUI textJacket01Kind;

        [SerializeField]
        private CustomSelectKind customJacket01;

        [SerializeField]
        private CanvasGroup cgJacket01Win;

        [SerializeField]
        private Toggle tglJacket02Kind;

        [SerializeField]
        private Image imgJacket02Kind;

        [SerializeField]
        private TextMeshProUGUI textJacket02Kind;

        [SerializeField]
        private CustomSelectKind customJacket02;

        [SerializeField]
        private CanvasGroup cgJacket02Win;

        [SerializeField]
        private Toggle tglJacket03Kind;

        [SerializeField]
        private Image imgJacket03Kind;

        [SerializeField]
        private TextMeshProUGUI textJacket03Kind;

        [SerializeField]
        private CustomSelectKind customJacket03;

        [SerializeField]
        private CanvasGroup cgJacket03Win;

        [SerializeField]
        private GameObject objSleeves;

        [SerializeField]
        private Toggle[] tglSleevesType;

        [SerializeField]
        private GameObject objOption;

        [SerializeField]
        private Toggle[] tglOption;

        [SerializeField]
        private GameObject objPtn01Separate;

        [SerializeField]
        private CvsColor cvsColor;

        [SerializeField]
        private Button btnMainColor01;

        [SerializeField]
        private Image imgMainColor01;

        [SerializeField]
        private Toggle tglPtn01Kind;

        [SerializeField]
        private Image imgPtn01Kind;

        [SerializeField]
        private TextMeshProUGUI textPtn01Kind;

        [SerializeField]
        private CustomSelectKind customPtn01;

        [SerializeField]
        private CanvasGroup cgPtn01Win;

        [SerializeField]
        private GameObject objPtnSetting01;

        [SerializeField]
        private Slider sldPtn01Width;

        [SerializeField]
        private TMP_InputField inpPtn01Width;

        [SerializeField]
        private Button btnPtn01Width;

        [SerializeField]
        private Slider sldPtn01Height;

        [SerializeField]
        private TMP_InputField inpPtn01Height;

        [SerializeField]
        private Button btnPtn01Height;

        [SerializeField]
        private Button btnPtnColor01;

        [SerializeField]
        private Image imgPtnColor01;

        [SerializeField]
        private GameObject objPtn02Separate;

        [SerializeField]
        private Button btnMainColor02;

        [SerializeField]
        private Image imgMainColor02;

        [SerializeField]
        private Toggle tglPtn02Kind;

        [SerializeField]
        private Image imgPtn02Kind;

        [SerializeField]
        private TextMeshProUGUI textPtn02Kind;

        [SerializeField]
        private CustomSelectKind customPtn02;

        [SerializeField]
        private CanvasGroup cgPtn02Win;

        [SerializeField]
        private GameObject objPtnSetting02;

        [SerializeField]
        private Slider sldPtn02Width;

        [SerializeField]
        private TMP_InputField inpPtn02Width;

        [SerializeField]
        private Button btnPtn02Width;

        [SerializeField]
        private Slider sldPtn02Height;

        [SerializeField]
        private TMP_InputField inpPtn02Height;

        [SerializeField]
        private Button btnPtn02Height;

        [SerializeField]
        private Button btnPtnColor02;

        [SerializeField]
        private Image imgPtnColor02;

        [SerializeField]
        private GameObject objPtn03Separate;

        [SerializeField]
        private Button btnMainColor03;

        [SerializeField]
        private Image imgMainColor03;

        [SerializeField]
        private Toggle tglPtn03Kind;

        [SerializeField]
        private Image imgPtn03Kind;

        [SerializeField]
        private TextMeshProUGUI textPtn03Kind;

        [SerializeField]
        private CustomSelectKind customPtn03;

        [SerializeField]
        private CanvasGroup cgPtn03Win;

        [SerializeField]
        private GameObject objPtnSetting03;

        [SerializeField]
        private Slider sldPtn03Width;

        [SerializeField]
        private TMP_InputField inpPtn03Width;

        [SerializeField]
        private Button btnPtn03Width;

        [SerializeField]
        private Slider sldPtn03Height;

        [SerializeField]
        private TMP_InputField inpPtn03Height;

        [SerializeField]
        private Button btnPtn03Height;

        [SerializeField]
        private Button btnPtnColor03;

        [SerializeField]
        private Image imgPtnColor03;

        [SerializeField]
        private GameObject objPtn04Separate;

        [SerializeField]
        private Button btnMainColor04;

        [SerializeField]
        private Image imgMainColor04;

        [SerializeField]
        private Toggle tglPtn04Kind;

        [SerializeField]
        private Image imgPtn04Kind;

        [SerializeField]
        private TextMeshProUGUI textPtn04Kind;

        [SerializeField]
        private CustomSelectKind customPtn04;

        [SerializeField]
        private CanvasGroup cgPtn04Win;

        [SerializeField]
        private GameObject objPtnSetting04;

        [SerializeField]
        private Slider sldPtn04Width;

        [SerializeField]
        private TMP_InputField inpPtn04Width;

        [SerializeField]
        private Button btnPtn04Width;

        [SerializeField]
        private Slider sldPtn04Height;

        [SerializeField]
        private TMP_InputField inpPtn04Height;

        [SerializeField]
        private Button btnPtn04Height;

        [SerializeField]
        private Button btnPtnColor04;

        [SerializeField]
        private Image imgPtnColor04;

        [SerializeField]
        private Toggle[] tglEmblemKind;

        [SerializeField]
        private Image[] imgEmblemKind;

        [SerializeField]
        private TextMeshProUGUI[] textEmblemKind;

        [SerializeField]
        private CustomSelectKind[] customEmblem;

        [SerializeField]
        private CanvasGroup[] cgEmblemWin;

        private int clothesType
        {
            get
            {
                return (int)typeClothes;
            }
        }

        private ChaControl chaCtrl
        {
            get
            {
                return Singleton<CustomBase>.Instance.chaCtrl;
            }
        }

        private ChaFileClothes clothes
        {
            get
            {
                return chaCtrl.nowCoordinate.clothes;
            }
        }

        private ChaFileClothes setClothes
        {
            get
            {
                return chaCtrl.chaFile.coordinate[chaCtrl.chaFile.status.coordinateType].clothes;
            }
        }

        private ChaFileClothes defClothes
        {
            get
            {
                return Singleton<CustomBase>.Instance.defChaInfo.coordinate[chaCtrl.chaFile.status.coordinateType].clothes;
            }
        }

        public void CalculateUI()
        {
            if ((bool)sldPtn01Width)
            {
                Slider slider = sldPtn01Width;
                Vector2 tiling = clothes.parts[clothesType].colorInfo[0].tiling;
                slider.value = tiling.x;
            }
            if ((bool)sldPtn01Height)
            {
                Slider slider2 = sldPtn01Height;
                Vector2 tiling2 = clothes.parts[clothesType].colorInfo[0].tiling;
                slider2.value = tiling2.y;
            }
            if ((bool)sldPtn02Width)
            {
                Slider slider3 = sldPtn02Width;
                Vector2 tiling3 = clothes.parts[clothesType].colorInfo[1].tiling;
                slider3.value = tiling3.x;
            }
            if ((bool)sldPtn02Height)
            {
                Slider slider4 = sldPtn02Height;
                Vector2 tiling4 = clothes.parts[clothesType].colorInfo[1].tiling;
                slider4.value = tiling4.y;
            }
            if ((bool)sldPtn03Width)
            {
                Slider slider5 = sldPtn03Width;
                Vector2 tiling5 = clothes.parts[clothesType].colorInfo[2].tiling;
                slider5.value = tiling5.x;
            }
            if ((bool)sldPtn03Height)
            {
                Slider slider6 = sldPtn03Height;
                Vector2 tiling6 = clothes.parts[clothesType].colorInfo[2].tiling;
                slider6.value = tiling6.y;
            }
            if ((bool)sldPtn04Width)
            {
                Slider slider7 = sldPtn04Width;
                Vector2 tiling7 = clothes.parts[clothesType].colorInfo[3].tiling;
                slider7.value = tiling7.x;
            }
            if ((bool)sldPtn04Height)
            {
                Slider slider8 = sldPtn04Height;
                Vector2 tiling8 = clothes.parts[clothesType].colorInfo[3].tiling;
                slider8.value = tiling8.y;
            }
            imgMainColor01.color = clothes.parts[clothesType].colorInfo[0].baseColor;
            imgMainColor02.color = clothes.parts[clothesType].colorInfo[1].baseColor;
            imgMainColor03.color = clothes.parts[clothesType].colorInfo[2].baseColor;
            if ((bool)imgMainColor04)
            {
                imgMainColor04.color = clothes.parts[clothesType].colorInfo[3].baseColor;
            }
            imgPtnColor01.color = clothes.parts[clothesType].colorInfo[0].patternColor;
            imgPtnColor02.color = clothes.parts[clothesType].colorInfo[1].patternColor;
            imgPtnColor03.color = clothes.parts[clothesType].colorInfo[2].patternColor;
            if ((bool)imgPtnColor04)
            {
                imgPtnColor04.color = clothes.parts[clothesType].colorInfo[3].patternColor;
            }
            if (clothesType == 2)
            {
                for (int i = 0; i < 2; i++)
                {
                    tglOption[i].isOn = !clothes.hideBraOpt[i];
                }
            }
            else if (clothesType == 3)
            {
                for (int j = 0; j < 2; j++)
                {
                    tglOption[j].isOn = !clothes.hideShortsOpt[j];
                }
            }
            else
            {
                for (int k = 0; k < 2; k++)
                {
                    tglOption[k].isOn = !clothes.parts[clothesType].hideOpt[k];
                }
            }
            if (!tglSleevesType.Any())
            {
                return;
            }
            for (int l = 0; l < 3; l++)
            {
                if ((bool)tglSleevesType[l])
                {
                    tglSleevesType[l].isOn = l == clothes.parts[clothesType].sleevesType;
                }
            }
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
            if (null != customClothes)
            {
                customClothes.UpdateCustomUI();
            }
            if (null != customSailor01)
            {
                customSailor01.UpdateCustomUI();
            }
            if (null != customSailor02)
            {
                customSailor02.UpdateCustomUI();
            }
            if (null != customSailor03)
            {
                customSailor03.UpdateCustomUI();
            }
            if (null != customJacket01)
            {
                customJacket01.UpdateCustomUI();
            }
            if (null != customJacket02)
            {
                customJacket02.UpdateCustomUI();
            }
            if (null != customJacket03)
            {
                customJacket03.UpdateCustomUI();
            }
            if (null != customPtn01)
            {
                customPtn01.UpdateCustomUI();
            }
            if (null != customPtn02)
            {
                customPtn02.UpdateCustomUI();
            }
            if (null != customPtn03)
            {
                customPtn03.UpdateCustomUI();
            }
            if (null != customPtn04)
            {
                customPtn04.UpdateCustomUI();
            }
            for (int i = 0; i < 2; i++)
            {
                if (null != customEmblem[i])
                {
                    customEmblem[i].UpdateCustomUI();
                }
            }
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTop01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTop02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTop03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTop04))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[3].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTopPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTopPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTopPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosTopPtn04))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[3].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBot01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBot02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBot03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBotPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBotPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBotPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBra01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBra02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBra03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBraPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBraPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosBraPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShorts01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShorts02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShorts03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShortsPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShortsPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosShortsPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGloves01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGloves02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGloves03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGlovesPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGlovesPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosGlovesPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanst01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanst02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanst03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanstPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanstPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosPanstPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocks01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocks02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocks03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocksPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocksPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosSocksPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoes01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoes02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoes03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoesPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoesPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosInnerShoesPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoes01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoes02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoes03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].baseColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoesPtn01))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[0].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoesPtn02))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[1].patternColor);
                    }
                    if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.CosOuterShoesPtn03))
                    {
                        cvsColor.SetColor(clothes.parts[clothesType].colorInfo[2].patternColor);
                    }
                    break;
            }
            ChangeSubPartsVisible();
            ChangeUseColorVisible();
            ChangeEmblemVisible();
        }

        public IEnumerator SetInputText()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            if ((bool)inpPtn01Width)
            {
                TMP_InputField tMP_InputField = inpPtn01Width;
                Vector2 tiling = clothes.parts[clothesType].colorInfo[0].tiling;
                tMP_InputField.text = CustomBase.ConvertTextFromRate(0, 100, tiling.x);
            }
            if ((bool)inpPtn01Height)
            {
                TMP_InputField tMP_InputField2 = inpPtn01Height;
                Vector2 tiling2 = clothes.parts[clothesType].colorInfo[0].tiling;
                tMP_InputField2.text = CustomBase.ConvertTextFromRate(0, 100, tiling2.y);
            }
            if ((bool)inpPtn02Width)
            {
                TMP_InputField tMP_InputField3 = inpPtn02Width;
                Vector2 tiling3 = clothes.parts[clothesType].colorInfo[1].tiling;
                tMP_InputField3.text = CustomBase.ConvertTextFromRate(0, 100, tiling3.x);
            }
            if ((bool)inpPtn02Height)
            {
                TMP_InputField tMP_InputField4 = inpPtn02Height;
                Vector2 tiling4 = clothes.parts[clothesType].colorInfo[1].tiling;
                tMP_InputField4.text = CustomBase.ConvertTextFromRate(0, 100, tiling4.y);
            }
            if ((bool)inpPtn03Width)
            {
                TMP_InputField tMP_InputField5 = inpPtn03Width;
                Vector2 tiling5 = clothes.parts[clothesType].colorInfo[2].tiling;
                tMP_InputField5.text = CustomBase.ConvertTextFromRate(0, 100, tiling5.x);
            }
            if ((bool)inpPtn03Height)
            {
                TMP_InputField tMP_InputField6 = inpPtn03Height;
                Vector2 tiling6 = clothes.parts[clothesType].colorInfo[2].tiling;
                tMP_InputField6.text = CustomBase.ConvertTextFromRate(0, 100, tiling6.y);
            }
            if ((bool)inpPtn04Width)
            {
                TMP_InputField tMP_InputField7 = inpPtn04Width;
                Vector2 tiling7 = clothes.parts[clothesType].colorInfo[3].tiling;
                tMP_InputField7.text = CustomBase.ConvertTextFromRate(0, 100, tiling7.x);
            }
            if ((bool)inpPtn04Height)
            {
                TMP_InputField tMP_InputField8 = inpPtn04Height;
                Vector2 tiling8 = clothes.parts[clothesType].colorInfo[3].tiling;
                tMP_InputField8.text = CustomBase.ConvertTextFromRate(0, 100, tiling8.y);
            }
        }

        public ChaListDefine.CategoryNo GetCategooryNo()
        {
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    return ChaListDefine.CategoryNo.co_top;
                case ChaFileDefine.ClothesKind.bot:
                    return ChaListDefine.CategoryNo.co_bot;
                case ChaFileDefine.ClothesKind.bra:
                    return ChaListDefine.CategoryNo.co_bra;
                case ChaFileDefine.ClothesKind.shorts:
                    return ChaListDefine.CategoryNo.co_shorts;
                case ChaFileDefine.ClothesKind.gloves:
                    return ChaListDefine.CategoryNo.co_gloves;
                case ChaFileDefine.ClothesKind.panst:
                    return ChaListDefine.CategoryNo.co_panst;
                case ChaFileDefine.ClothesKind.socks:
                    return ChaListDefine.CategoryNo.co_socks;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    return ChaListDefine.CategoryNo.co_shoes;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    return ChaListDefine.CategoryNo.co_shoes;
                default:
                    return ChaListDefine.CategoryNo.cha_sample_f;
            }
        }

        private bool CheckUseColor(int _type, ref bool[] use)
        {
            bool flag = true;
            if (_type == 0)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[_type].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = false;
                }
            }
            if (flag)
            {
                ChaClothesComponent chaClothesComponent = chaCtrl.cusClothesCmp[_type];
                if (null != chaClothesComponent)
                {
                    use[0] = chaClothesComponent.useColorN01;
                    use[1] = chaClothesComponent.useColorN02;
                    use[2] = chaClothesComponent.useColorN03;
                }
                bool flag2 = !(null == chaClothesComponent) && 0 != chaClothesComponent.objOpt01.Length;
                bool flag3 = !(null == chaClothesComponent) && 0 != chaClothesComponent.objOpt02.Length;
                tglOption[0].gameObject.SetActiveIfDifferent(flag2);
                tglOption[1].gameObject.SetActiveIfDifferent(flag3);
                bool active = flag2 || flag3;
                objOption.SetActiveIfDifferent(active);
                if (_type == 0)
                {
                    bool flag4 = !(null == chaClothesComponent) && 0 != chaClothesComponent.objSleeves01.Length;
                    bool flag5 = !(null == chaClothesComponent) && 0 != chaClothesComponent.objSleeves02.Length;
                    bool flag6 = !(null == chaClothesComponent) && 0 != chaClothesComponent.objSleeves03.Length;
                    tglSleevesType[0].gameObject.SetActiveIfDifferent(flag4);
                    tglSleevesType[1].gameObject.SetActiveIfDifferent(flag5);
                    tglSleevesType[2].gameObject.SetActiveIfDifferent(flag6);
                    bool active2 = flag4 || flag5 || flag6;
                    objSleeves.SetActiveIfDifferent(active2);
                }
            }
            else
            {
                objOption.SetActiveIfDifferent(false);
                objSleeves.SetActiveIfDifferent(false);
                ChaClothesComponent[] cusClothesSubCmp = chaCtrl.cusClothesSubCmp;
                foreach (ChaClothesComponent chaClothesComponent2 in cusClothesSubCmp)
                {
                    if (!(null == chaClothesComponent2))
                    {
                        use[0] |= chaClothesComponent2.useColorN01;
                        use[1] |= chaClothesComponent2.useColorN02;
                        use[2] |= chaClothesComponent2.useColorN03;
                        use[3] |= null != chaClothesComponent2.rendAccessory;
                    }
                }
            }
            return true;
        }

        public void ChangeUseColorVisible()
        {
            bool[] use = new bool[4];
            if (!CheckUseColor(clothesType, ref use))
            {
                return;
            }
            if ((bool)objPtn01Separate)
            {
                objPtn01Separate.SetActiveIfDifferent(use[0]);
            }
            if ((bool)btnMainColor01)
            {
                btnMainColor01.transform.parent.gameObject.SetActiveIfDifferent(use[0]);
            }
            if ((bool)tglPtn01Kind)
            {
                tglPtn01Kind.transform.parent.gameObject.SetActiveIfDifferent(use[0]);
            }
            if ((bool)sldPtn01Width)
            {
                sldPtn01Width.transform.parent.gameObject.SetActiveIfDifferent(use[0]);
            }
            if ((bool)sldPtn01Height)
            {
                sldPtn01Height.transform.parent.gameObject.SetActiveIfDifferent(use[0]);
            }
            if ((bool)btnPtnColor01)
            {
                btnPtnColor01.transform.parent.gameObject.SetActiveIfDifferent(use[0]);
            }
            if ((bool)objPtn02Separate)
            {
                objPtn02Separate.SetActiveIfDifferent(use[1]);
            }
            if ((bool)btnMainColor02)
            {
                btnMainColor02.transform.parent.gameObject.SetActiveIfDifferent(use[1]);
            }
            if ((bool)tglPtn02Kind)
            {
                tglPtn02Kind.transform.parent.gameObject.SetActiveIfDifferent(use[1]);
            }
            if ((bool)sldPtn02Width)
            {
                sldPtn02Width.transform.parent.gameObject.SetActiveIfDifferent(use[1]);
            }
            if ((bool)sldPtn02Height)
            {
                sldPtn02Height.transform.parent.gameObject.SetActiveIfDifferent(use[1]);
            }
            if ((bool)btnPtnColor02)
            {
                btnPtnColor02.transform.parent.gameObject.SetActiveIfDifferent(use[1]);
            }
            if ((bool)objPtn03Separate)
            {
                objPtn03Separate.SetActiveIfDifferent(use[2]);
            }
            if ((bool)btnMainColor03)
            {
                btnMainColor03.transform.parent.gameObject.SetActiveIfDifferent(use[2]);
            }
            if ((bool)tglPtn03Kind)
            {
                tglPtn03Kind.transform.parent.gameObject.SetActiveIfDifferent(use[2]);
            }
            if ((bool)sldPtn03Width)
            {
                sldPtn03Width.transform.parent.gameObject.SetActiveIfDifferent(use[2]);
            }
            if ((bool)sldPtn03Height)
            {
                sldPtn03Height.transform.parent.gameObject.SetActiveIfDifferent(use[2]);
            }
            if ((bool)btnPtnColor03)
            {
                btnPtnColor03.transform.parent.gameObject.SetActiveIfDifferent(use[2]);
            }
            if ((bool)objPtn04Separate)
            {
                objPtn04Separate.SetActiveIfDifferent(use[3]);
            }
            if ((bool)btnMainColor04)
            {
                btnMainColor04.transform.parent.gameObject.SetActiveIfDifferent(use[3]);
            }
            if ((bool)tglPtn04Kind)
            {
                tglPtn04Kind.transform.parent.gameObject.SetActiveIfDifferent(use[3]);
            }
            if ((bool)sldPtn04Width)
            {
                sldPtn04Width.transform.parent.gameObject.SetActiveIfDifferent(use[3]);
            }
            if ((bool)sldPtn04Height)
            {
                sldPtn04Height.transform.parent.gameObject.SetActiveIfDifferent(use[3]);
            }
            if ((bool)btnPtnColor04)
            {
                btnPtnColor04.transform.parent.gameObject.SetActiveIfDifferent(use[3]);
            }
            bool flag = true;
            for (int i = 0; i < use.Length; i++)
            {
                if (use[i])
                {
                    flag = false;
                }
            }
            if (flag)
            {
                cvsColor.Close();
            }
        }

        public void ChangeEmblemVisible()
        {
            for (int i = 0; i < 2; i++)
            {
                bool active = chaCtrl.IsEmblem(clothesType, i);
                if ((bool)tglEmblemKind[i])
                {
                    tglEmblemKind[i].transform.parent.gameObject.SetActiveIfDifferent(active);
                }
            }
        }

        public void ChangeSubPartsVisible()
        {
            if (typeClothes != 0)
            {
                return;
            }
            ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
            if (listInfo != null)
            {
                if (listInfo.Kind == 1)
                {
                    tglSailor01Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                    tglSailor02Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                    tglSailor03Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                    tglJacket01Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket02Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket03Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
                else if (listInfo.Kind == 2)
                {
                    tglSailor01Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglSailor02Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglSailor03Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket01Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                    tglJacket02Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                    tglJacket03Kind.transform.parent.gameObject.SetActiveIfDifferent(true);
                }
                else
                {
                    tglSailor01Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglSailor02Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglSailor03Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket01Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket02Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                    tglJacket03Kind.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
            }
        }

        public void UpdateSelectClothes(string name, Sprite sp, int index)
        {
            if ((bool)textClothesKind)
            {
                textClothesKind.text = name;
            }
            if ((bool)imgClothesKind)
            {
                imgClothesKind.sprite = sp;
            }
            if (clothes.parts[clothesType].id == index)
            {
                return;
            }
            clothes.parts[clothesType].id = index;
            setClothes.parts[clothesType].id = index;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    {
                        clothes.parts[clothesType].sleevesType = 0;
                        setClothes.parts[clothesType].sleevesType = 0;
                        FuncUpdateClothesTop();
                        int num = Enum.GetNames(typeof(ChaFileDefine.ClothesSubKind)).Length;
                        for (int i = 0; i < num; i++)
                        {
                            setClothes.subPartsId[i] = clothes.subPartsId[i];
                        }
                        switch (chaCtrl.infoClothes[0].Kind)
                        {
                            case 1:
                                customSailor01.UpdateCustomUI();
                                customSailor02.UpdateCustomUI();
                                customSailor03.UpdateCustomUI();
                                break;
                            case 2:
                                customJacket01.UpdateCustomUI();
                                customJacket02.UpdateCustomUI();
                                customJacket03.UpdateCustomUI();
                                break;
                        }
                        Singleton<CustomBase>.Instance.updateCvsCosTop = true;
                        Singleton<CustomBase>.Instance.updateCvsCosBot = true;
                        break;
                    }
                case ChaFileDefine.ClothesKind.bot:
                    FuncUpdateClothesBot();
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    FuncUpdateClothesBra();
                    Singleton<CustomBase>.Instance.updateCvsCosShorts = true;
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    FuncUpdateClothesShorts();
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    FuncUpdateClothesGloves();
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    FuncUpdateClothesPanst();
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    FuncUpdateClothesSocks();
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    FuncUpdateClothesInnerShoes();
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    FuncUpdateClothesOuterShoes();
                    break;
            }
            ChangeSubPartsVisible();
            ChangeUseColorVisible();
            ChangeEmblemVisible();
        }

        public bool FuncUpdateClothesTop()
        {
            int id = setClothes.parts[0].id;
            int[] array = new int[3]
            {
                setClothes.subPartsId[0],
                setClothes.subPartsId[1],
                setClothes.subPartsId[2]
            };
            chaCtrl.ChangeClothesTop(id, array[0], array[1], array[2], true);
            return true;
        }

        public bool FuncUpdateClothesBot()
        {
            int id = setClothes.parts[1].id;
            chaCtrl.ChangeClothesBot(id, true);
            return true;
        }

        public bool FuncUpdateClothesBra()
        {
            int id = setClothes.parts[2].id;
            chaCtrl.ChangeClothesBra(id, true);
            return true;
        }

        public bool FuncUpdateClothesShorts()
        {
            int id = setClothes.parts[3].id;
            chaCtrl.ChangeClothesShorts(id, true);
            return true;
        }

        public bool FuncUpdateClothesGloves()
        {
            int id = setClothes.parts[4].id;
            chaCtrl.ChangeClothesGloves(id, true);
            return true;
        }

        public bool FuncUpdateClothesPanst()
        {
            int id = setClothes.parts[5].id;
            chaCtrl.ChangeClothesPanst(id, true);
            return true;
        }

        public bool FuncUpdateClothesSocks()
        {
            int id = setClothes.parts[6].id;
            chaCtrl.ChangeClothesSocks(id, true);
            return true;
        }

        public bool FuncUpdateClothesInnerShoes()
        {
            int id = setClothes.parts[7].id;
            chaCtrl.ChangeClothesShoes(0, id, true);
            return true;
        }

        public bool FuncUpdateClothesOuterShoes()
        {
            int id = setClothes.parts[8].id;
            chaCtrl.ChangeClothesShoes(1, id, true);
            return true;
        }

        public void UpdateSelectSailor01(string name, Sprite sp, int index)
        {
            if ((bool)textSailor01Kind)
            {
                textSailor01Kind.text = name;
            }
            if ((bool)imgSailor01Kind)
            {
                imgSailor01Kind.sprite = sp;
            }
            if (clothes.subPartsId[0] != index)
            {
                clothes.subPartsId[0] = index;
                setClothes.subPartsId[0] = index;
                FuncUpdateSailor();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public void UpdateSelectSailor02(string name, Sprite sp, int index)
        {
            if ((bool)textSailor02Kind)
            {
                textSailor02Kind.text = name;
            }
            if ((bool)imgSailor02Kind)
            {
                imgSailor02Kind.sprite = sp;
            }
            if (clothes.subPartsId[1] != index)
            {
                clothes.subPartsId[1] = index;
                setClothes.subPartsId[1] = index;
                FuncUpdateSailor();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public void UpdateSelectSailor03(string name, Sprite sp, int index)
        {
            if ((bool)textSailor03Kind)
            {
                textSailor03Kind.text = name;
            }
            if ((bool)imgSailor03Kind)
            {
                imgSailor03Kind.sprite = sp;
            }
            if (clothes.subPartsId[2] != index)
            {
                clothes.subPartsId[2] = index;
                setClothes.subPartsId[2] = index;
                FuncUpdateSailor();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public bool FuncUpdateSailor()
        {
            int[] array = new int[3]
            {
                setClothes.subPartsId[0],
                setClothes.subPartsId[1],
                setClothes.subPartsId[2]
            };
            chaCtrl.ChangeClothesTop(1, array[0], array[1], array[2], true);
            return true;
        }

        public void UpdateSelectJacket01(string name, Sprite sp, int index)
        {
            if ((bool)textJacket01Kind)
            {
                textJacket01Kind.text = name;
            }
            if ((bool)imgJacket01Kind)
            {
                imgJacket01Kind.sprite = sp;
            }
            if (clothes.subPartsId[0] != index)
            {
                clothes.subPartsId[0] = index;
                setClothes.subPartsId[0] = index;
                FuncUpdateJacket();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public void UpdateSelectJacket02(string name, Sprite sp, int index)
        {
            if ((bool)textJacket02Kind)
            {
                textJacket02Kind.text = name;
            }
            if ((bool)imgJacket02Kind)
            {
                imgJacket02Kind.sprite = sp;
            }
            if (clothes.subPartsId[1] != index)
            {
                clothes.subPartsId[1] = index;
                setClothes.subPartsId[1] = index;
                FuncUpdateJacket();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public void UpdateSelectJacket03(string name, Sprite sp, int index)
        {
            if ((bool)textJacket03Kind)
            {
                textJacket03Kind.text = name;
            }
            if ((bool)imgJacket03Kind)
            {
                imgJacket03Kind.sprite = sp;
            }
            if (clothes.subPartsId[2] != index)
            {
                clothes.subPartsId[2] = index;
                setClothes.subPartsId[2] = index;
                FuncUpdateJacket();
                ChangeUseColorVisible();
                ChangeEmblemVisible();
            }
        }

        public bool FuncUpdateJacket()
        {
            int[] array = new int[3]
            {
                setClothes.subPartsId[0],
                setClothes.subPartsId[1],
                setClothes.subPartsId[2]
            };
            chaCtrl.ChangeClothesTop(2, array[0], array[1], array[2], true);
            return true;
        }

        public void UpdateSelectPtn01(string name, Sprite sp, int index)
        {
            if ((bool)textPtn01Kind)
            {
                textPtn01Kind.text = name;
            }
            if ((bool)imgPtn01Kind)
            {
                imgPtn01Kind.sprite = sp;
            }
            if (clothes.parts[clothesType].colorInfo[0].pattern != index)
            {
                clothes.parts[clothesType].colorInfo[0].pattern = index;
                setClothes.parts[clothesType].colorInfo[0].pattern = index;
                FuncUpdatePattern01();
            }
            if ((bool)objPtnSetting01)
            {
                objPtnSetting01.SetActiveIfDifferent(0 != index);
            }
        }

        public bool FuncUpdatePattern01()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                chaCtrl.ChangeCustomClothes(false, 0, false, true, false, false, false);
                chaCtrl.ChangeCustomClothes(false, 1, false, true, false, false, false);
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, false, true, false, false, false);
            }
            return true;
        }

        public void UpdateSelectPtn02(string name, Sprite sp, int index)
        {
            if ((bool)textPtn02Kind)
            {
                textPtn02Kind.text = name;
            }
            if ((bool)imgPtn02Kind)
            {
                imgPtn02Kind.sprite = sp;
            }
            if (clothes.parts[clothesType].colorInfo[1].pattern != index)
            {
                clothes.parts[clothesType].colorInfo[1].pattern = index;
                setClothes.parts[clothesType].colorInfo[1].pattern = index;
                FuncUpdatePattern02();
            }
            if ((bool)objPtnSetting02)
            {
                objPtnSetting02.SetActiveIfDifferent(0 != index);
            }
        }

        public bool FuncUpdatePattern02()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                chaCtrl.ChangeCustomClothes(false, 0, false, false, true, false, false);
                chaCtrl.ChangeCustomClothes(false, 1, false, false, true, false, false);
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, false, false, true, false, false);
            }
            return true;
        }

        public void UpdateSelectPtn03(string name, Sprite sp, int index)
        {
            if ((bool)textPtn03Kind)
            {
                textPtn03Kind.text = name;
            }
            if ((bool)imgPtn03Kind)
            {
                imgPtn03Kind.sprite = sp;
            }
            if (clothes.parts[clothesType].colorInfo[2].pattern != index)
            {
                clothes.parts[clothesType].colorInfo[2].pattern = index;
                setClothes.parts[clothesType].colorInfo[2].pattern = index;
                FuncUpdatePattern03();
            }
            if ((bool)objPtnSetting03)
            {
                objPtnSetting03.SetActiveIfDifferent(0 != index);
            }
        }

        public bool FuncUpdatePattern03()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                chaCtrl.ChangeCustomClothes(false, 0, false, false, false, true, false);
                chaCtrl.ChangeCustomClothes(false, 1, false, false, false, true, false);
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, false, false, false, true, false);
            }
            return true;
        }

        public void UpdateSelectPtn04(string name, Sprite sp, int index)
        {
            if ((bool)textPtn04Kind)
            {
                textPtn04Kind.text = name;
            }
            if ((bool)imgPtn04Kind)
            {
                imgPtn04Kind.sprite = sp;
            }
            if (clothes.parts[clothesType].colorInfo[3].pattern != index)
            {
                clothes.parts[clothesType].colorInfo[3].pattern = index;
                setClothes.parts[clothesType].colorInfo[3].pattern = index;
                FuncUpdatePattern04();
            }
            if ((bool)objPtnSetting04)
            {
                objPtnSetting04.SetActiveIfDifferent(0 != index);
            }
        }

        public bool FuncUpdatePattern04()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                chaCtrl.ChangeCustomClothes(false, 2, false, false, false, false, true);
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, false, false, false, false, true);
            }
            return true;
        }

        public void UpdateSelectEmblem(string name, Sprite sp, int index, int arrNo)
        {
            if ((bool)textEmblemKind[arrNo])
            {
                textEmblemKind[arrNo].text = name;
            }
            if ((bool)imgEmblemKind[arrNo])
            {
                imgEmblemKind[arrNo].sprite = sp;
            }
            if (arrNo == 0)
            {
                if (clothes.parts[clothesType].emblemeId != index)
                {
                    clothes.parts[clothesType].emblemeId = index;
                    setClothes.parts[clothesType].emblemeId = index;
                    FuncUpdateEmblem(arrNo);
                }
            }
            else if (clothes.parts[clothesType].emblemeId2 != index)
            {
                clothes.parts[clothesType].emblemeId2 = index;
                setClothes.parts[clothesType].emblemeId2 = index;
                FuncUpdateEmblem(arrNo);
            }
        }

        public bool FuncUpdateEmblem(int arrNo)
        {
            chaCtrl.ChangeCustomEmblem(clothesType, arrNo);
            return true;
        }

        public void UpdateCosColor01(Color color)
        {
            clothes.parts[clothesType].colorInfo[0].baseColor = color;
            setClothes.parts[clothesType].colorInfo[0].baseColor = color;
            imgMainColor01.color = color;
            FuncUpdateCosColor();
        }

        public bool FuncUpdateCosColor()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                for (int i = 0; i < clothes.subPartsId.Length; i++)
                {
                    chaCtrl.ChangeCustomClothes(false, i, true, false, false, false, false);
                }
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, true, false, false, false, false);
            }
            return true;
        }

        public void UpdateCosColor02(Color color)
        {
            clothes.parts[clothesType].colorInfo[1].baseColor = color;
            setClothes.parts[clothesType].colorInfo[1].baseColor = color;
            imgMainColor02.color = color;
            FuncUpdateCosColor();
        }

        public void UpdateCosColor03(Color color)
        {
            clothes.parts[clothesType].colorInfo[2].baseColor = color;
            setClothes.parts[clothesType].colorInfo[2].baseColor = color;
            imgMainColor03.color = color;
            FuncUpdateCosColor();
        }

        public void UpdateCosColor04(Color color)
        {
            clothes.parts[clothesType].colorInfo[3].baseColor = color;
            setClothes.parts[clothesType].colorInfo[3].baseColor = color;
            imgMainColor04.color = color;
            FuncUpdateCosColor();
        }

        public void UpdatePtnColor01(Color color)
        {
            clothes.parts[clothesType].colorInfo[0].patternColor = color;
            setClothes.parts[clothesType].colorInfo[0].patternColor = color;
            imgPtnColor01.color = color;
            FuncUpdateCosColor();
        }

        public void UpdatePtnColor02(Color color)
        {
            clothes.parts[clothesType].colorInfo[1].patternColor = color;
            setClothes.parts[clothesType].colorInfo[1].patternColor = color;
            imgPtnColor02.color = color;
            FuncUpdateCosColor();
        }

        public void UpdatePtnColor03(Color color)
        {
            clothes.parts[clothesType].colorInfo[2].patternColor = color;
            setClothes.parts[clothesType].colorInfo[2].patternColor = color;
            imgPtnColor03.color = color;
            FuncUpdateCosColor();
        }

        public void UpdatePtnColor04(Color color)
        {
            clothes.parts[clothesType].colorInfo[3].patternColor = color;
            setClothes.parts[clothesType].colorInfo[3].patternColor = color;
            imgPtnColor04.color = color;
            FuncUpdateCosColor();
        }

        public bool FuncUpdateAllPtnAndColor()
        {
            bool flag = false;
            if (typeClothes == ChaFileDefine.ClothesKind.top)
            {
                ListInfoBase listInfo = chaCtrl.lstCtrl.GetListInfo(ChaListDefine.CategoryNo.co_top, clothes.parts[clothesType].id);
                if (listInfo == null)
                {
                    return false;
                }
                if (listInfo.Kind == 1 || listInfo.Kind == 2)
                {
                    flag = true;
                }
            }
            if (flag)
            {
                chaCtrl.ChangeCustomClothes(false, 0, true, true, true, true, false);
                chaCtrl.ChangeCustomClothes(false, 1, true, true, true, true, false);
                chaCtrl.ChangeCustomClothes(false, 2, true, false, false, false, true);
            }
            else
            {
                chaCtrl.ChangeCustomClothes(true, clothesType, true, true, true, true, true);
            }
            return true;
        }

        public void SetDefaultColorWindow(int no)
        {
            CvsColor.ConnectColorKind kind = CvsColor.ConnectColorKind.CosTop01;
            string winTitle = string.Empty;
            switch (no)
            {
                case 0:
                    kind = CvsColor.ConnectColorKind.CosTop01;
                    winTitle = "トップスの色０１";
                    break;
                case 1:
                    kind = CvsColor.ConnectColorKind.CosBot01;
                    winTitle = "ボトムスの色０１";
                    break;
                case 2:
                    kind = CvsColor.ConnectColorKind.CosBra01;
                    winTitle = "ブラの色０１";
                    break;
                case 3:
                    kind = CvsColor.ConnectColorKind.CosShorts01;
                    winTitle = "ショーツの色０１";
                    break;
                case 4:
                    kind = CvsColor.ConnectColorKind.CosGloves01;
                    winTitle = "手袋の色０１";
                    break;
                case 5:
                    kind = CvsColor.ConnectColorKind.CosPanst01;
                    winTitle = "パンストの色０１";
                    break;
                case 6:
                    kind = CvsColor.ConnectColorKind.CosSocks01;
                    winTitle = "靴下の色０１";
                    break;
                case 7:
                    kind = CvsColor.ConnectColorKind.CosInnerShoes01;
                    winTitle = "内履きの色０１";
                    break;
                case 8:
                    kind = CvsColor.ConnectColorKind.CosOuterShoes01;
                    winTitle = "外履きの色０１";
                    break;
            }
            cvsColor.Setup(winTitle, kind, clothes.parts[no].colorInfo[0].baseColor, UpdateCosColor01, false);
            bool[] use = new bool[4];
            if (CheckUseColor(no, ref use))
            {
                bool flag = true;
                for (int i = 0; i < use.Length; i++)
                {
                    if (use[i])
                    {
                        flag = false;
                    }
                }
                if (flag)
                {
                    cvsColor.Close();
                }
            }
            else
            {
                cvsColor.Close();
            }
        }

        protected virtual void Awake()
        {
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    textInitBtnName.text = "トップスを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    textInitBtnName.text = "ボトムスを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    textInitBtnName.text = "ブラを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    textInitBtnName.text = "ショーツを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    textInitBtnName.text = "手袋を初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    textInitBtnName.text = "パンストを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    textInitBtnName.text = "靴下を初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    textInitBtnName.text = "内履きを初期の状態に戻す";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    textInitBtnName.text = "外履きを初期の状態に戻す";
                    break;
            }
        }

        protected virtual void Start()
        {
            if ((bool)inpPtn01Width)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn01Width);
            }
            if ((bool)inpPtn01Height)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn01Height);
            }
            if ((bool)inpPtn02Width)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn02Width);
            }
            if ((bool)inpPtn02Height)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn02Height);
            }
            if ((bool)inpPtn03Width)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn03Width);
            }
            if ((bool)inpPtn03Height)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn03Height);
            }
            if ((bool)inpPtn04Width)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn04Width);
            }
            if ((bool)inpPtn04Height)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpPtn04Height);
            }
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosTop += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosBot += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosBra += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosShorts += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosGloves += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosPanst += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosSocks += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosInnerShoes += UpdateCustomUI;
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    Singleton<CustomBase>.Instance.actUpdateCvsCosOuterShoes += UpdateCustomUI;
                    break;
            }
            tglClothesKind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                if ((bool)cgClothesWin)
                {
                    bool flag13 = cgClothesWin.alpha != 0f;
                    if (flag13 != isOn)
                    {
                        cgClothesWin.Enable(isOn);
                        if (isOn)
                        {
                            if ((bool)tglSailor01Kind)
                            {
                                tglSailor01Kind.isOn = false;
                            }
                            if ((bool)tglSailor02Kind)
                            {
                                tglSailor02Kind.isOn = false;
                            }
                            if ((bool)tglSailor03Kind)
                            {
                                tglSailor03Kind.isOn = false;
                            }
                            if ((bool)tglJacket01Kind)
                            {
                                tglJacket01Kind.isOn = false;
                            }
                            if ((bool)tglJacket02Kind)
                            {
                                tglJacket02Kind.isOn = false;
                            }
                            if ((bool)tglJacket03Kind)
                            {
                                tglJacket03Kind.isOn = false;
                            }
                            tglPtn01Kind.isOn = false;
                            tglPtn02Kind.isOn = false;
                            tglPtn03Kind.isOn = false;
                            if ((bool)tglPtn04Kind)
                            {
                                tglPtn04Kind.isOn = false;
                            }
                            for (int num6 = 0; num6 < 2; num6++)
                            {
                                if ((bool)tglEmblemKind[num6])
                                {
                                    tglEmblemKind[num6].isOn = false;
                                }
                            }
                        }
                    }
                }
            });
            if ((bool)tglSailor01Kind)
            {
                tglSailor01Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgSailor01Win)
                    {
                        bool flag12 = cgSailor01Win.alpha != 0f;
                        if (flag12 != isOn)
                        {
                            cgSailor01Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int num5 = 0; num5 < 2; num5++)
                                {
                                    if ((bool)tglEmblemKind[num5])
                                    {
                                        tglEmblemKind[num5].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglSailor02Kind)
            {
                tglSailor02Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgSailor02Win)
                    {
                        bool flag11 = cgSailor02Win.alpha != 0f;
                        if (flag11 != isOn)
                        {
                            cgSailor02Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int num4 = 0; num4 < 2; num4++)
                                {
                                    if ((bool)tglEmblemKind[num4])
                                    {
                                        tglEmblemKind[num4].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglSailor03Kind)
            {
                tglSailor03Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgSailor03Win)
                    {
                        bool flag10 = cgSailor03Win.alpha != 0f;
                        if (flag10 != isOn)
                        {
                            cgSailor03Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int num3 = 0; num3 < 2; num3++)
                                {
                                    if ((bool)tglEmblemKind[num3])
                                    {
                                        tglEmblemKind[num3].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglJacket01Kind)
            {
                tglJacket01Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgJacket01Win)
                    {
                        bool flag9 = cgJacket01Win.alpha != 0f;
                        if (flag9 != isOn)
                        {
                            cgJacket01Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int num2 = 0; num2 < 2; num2++)
                                {
                                    if ((bool)tglEmblemKind[num2])
                                    {
                                        tglEmblemKind[num2].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglJacket02Kind)
            {
                tglJacket02Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgJacket02Win)
                    {
                        bool flag8 = cgJacket02Win.alpha != 0f;
                        if (flag8 != isOn)
                        {
                            cgJacket02Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int num = 0; num < 2; num++)
                                {
                                    if ((bool)tglEmblemKind[num])
                                    {
                                        tglEmblemKind[num].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglJacket03Kind)
            {
                tglJacket03Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgJacket03Win)
                    {
                        bool flag7 = cgJacket03Win.alpha != 0f;
                        if (flag7 != isOn)
                        {
                            cgJacket03Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                tglPtn04Kind.isOn = false;
                                for (int n = 0; n < 2; n++)
                                {
                                    if ((bool)tglEmblemKind[n])
                                    {
                                        tglEmblemKind[n].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            tglPtn01Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                if ((bool)cgPtn01Win)
                {
                    bool flag6 = cgPtn01Win.alpha != 0f;
                    if (flag6 != isOn)
                    {
                        cgPtn01Win.Enable(isOn);
                        if (isOn)
                        {
                            tglClothesKind.isOn = false;
                            if ((bool)tglSailor01Kind)
                            {
                                tglSailor01Kind.isOn = false;
                            }
                            if ((bool)tglSailor02Kind)
                            {
                                tglSailor02Kind.isOn = false;
                            }
                            if ((bool)tglSailor03Kind)
                            {
                                tglSailor03Kind.isOn = false;
                            }
                            if ((bool)tglJacket01Kind)
                            {
                                tglJacket01Kind.isOn = false;
                            }
                            if ((bool)tglJacket02Kind)
                            {
                                tglJacket02Kind.isOn = false;
                            }
                            if ((bool)tglJacket03Kind)
                            {
                                tglJacket03Kind.isOn = false;
                            }
                            tglPtn02Kind.isOn = false;
                            tglPtn03Kind.isOn = false;
                            if ((bool)tglPtn04Kind)
                            {
                                tglPtn04Kind.isOn = false;
                            }
                            for (int m = 0; m < 2; m++)
                            {
                                if ((bool)tglEmblemKind[m])
                                {
                                    tglEmblemKind[m].isOn = false;
                                }
                            }
                        }
                    }
                }
            });
            tglPtn02Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                if ((bool)cgPtn02Win)
                {
                    bool flag5 = cgPtn02Win.alpha != 0f;
                    if (flag5 != isOn)
                    {
                        cgPtn02Win.Enable(isOn);
                        if (isOn)
                        {
                            tglClothesKind.isOn = false;
                            if ((bool)tglSailor01Kind)
                            {
                                tglSailor01Kind.isOn = false;
                            }
                            if ((bool)tglSailor02Kind)
                            {
                                tglSailor02Kind.isOn = false;
                            }
                            if ((bool)tglSailor03Kind)
                            {
                                tglSailor03Kind.isOn = false;
                            }
                            if ((bool)tglJacket01Kind)
                            {
                                tglJacket01Kind.isOn = false;
                            }
                            if ((bool)tglJacket02Kind)
                            {
                                tglJacket02Kind.isOn = false;
                            }
                            if ((bool)tglJacket03Kind)
                            {
                                tglJacket03Kind.isOn = false;
                            }
                            tglPtn01Kind.isOn = false;
                            tglPtn03Kind.isOn = false;
                            if ((bool)tglPtn04Kind)
                            {
                                tglPtn04Kind.isOn = false;
                            }
                            for (int l = 0; l < 2; l++)
                            {
                                if ((bool)tglEmblemKind[l])
                                {
                                    tglEmblemKind[l].isOn = false;
                                }
                            }
                        }
                    }
                }
            });
            tglPtn03Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                if ((bool)cgPtn03Win)
                {
                    bool flag4 = cgPtn03Win.alpha != 0f;
                    if (flag4 != isOn)
                    {
                        cgPtn03Win.Enable(isOn);
                        if (isOn)
                        {
                            tglClothesKind.isOn = false;
                            if ((bool)tglSailor01Kind)
                            {
                                tglSailor01Kind.isOn = false;
                            }
                            if ((bool)tglSailor02Kind)
                            {
                                tglSailor02Kind.isOn = false;
                            }
                            if ((bool)tglSailor03Kind)
                            {
                                tglSailor03Kind.isOn = false;
                            }
                            if ((bool)tglJacket01Kind)
                            {
                                tglJacket01Kind.isOn = false;
                            }
                            if ((bool)tglJacket02Kind)
                            {
                                tglJacket02Kind.isOn = false;
                            }
                            if ((bool)tglJacket03Kind)
                            {
                                tglJacket03Kind.isOn = false;
                            }
                            tglPtn01Kind.isOn = false;
                            tglPtn02Kind.isOn = false;
                            if ((bool)tglPtn04Kind)
                            {
                                tglPtn04Kind.isOn = false;
                            }
                            for (int k = 0; k < 2; k++)
                            {
                                if ((bool)tglEmblemKind[k])
                                {
                                    tglEmblemKind[k].isOn = false;
                                }
                            }
                        }
                    }
                }
            });
            if ((bool)tglPtn04Kind)
            {
                tglPtn04Kind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgPtn04Win)
                    {
                        bool flag3 = cgPtn04Win.alpha != 0f;
                        if (flag3 != isOn)
                        {
                            cgPtn04Win.Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                tglSailor01Kind.isOn = false;
                                tglSailor02Kind.isOn = false;
                                tglSailor03Kind.isOn = false;
                                tglJacket01Kind.isOn = false;
                                tglJacket02Kind.isOn = false;
                                tglJacket03Kind.isOn = false;
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                for (int j = 0; j < 2; j++)
                                {
                                    if ((bool)tglEmblemKind[j])
                                    {
                                        tglEmblemKind[j].isOn = false;
                                    }
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglEmblemKind[0])
            {
                tglEmblemKind[0].OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgEmblemWin[0])
                    {
                        bool flag2 = cgEmblemWin[0].alpha != 0f;
                        if (flag2 != isOn)
                        {
                            cgEmblemWin[0].Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                if ((bool)tglSailor01Kind)
                                {
                                    tglSailor01Kind.isOn = false;
                                }
                                if ((bool)tglSailor02Kind)
                                {
                                    tglSailor02Kind.isOn = false;
                                }
                                if ((bool)tglSailor03Kind)
                                {
                                    tglSailor03Kind.isOn = false;
                                }
                                if ((bool)tglJacket01Kind)
                                {
                                    tglJacket01Kind.isOn = false;
                                }
                                if ((bool)tglJacket02Kind)
                                {
                                    tglJacket02Kind.isOn = false;
                                }
                                if ((bool)tglJacket03Kind)
                                {
                                    tglJacket03Kind.isOn = false;
                                }
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                if ((bool)tglPtn04Kind)
                                {
                                    tglPtn04Kind.isOn = false;
                                }
                                if ((bool)tglEmblemKind[1])
                                {
                                    tglEmblemKind[1].isOn = false;
                                }
                            }
                        }
                    }
                });
            }
            if ((bool)tglEmblemKind[1])
            {
                tglEmblemKind[1].OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if ((bool)cgEmblemWin[1])
                    {
                        bool flag = cgEmblemWin[1].alpha != 0f;
                        if (flag != isOn)
                        {
                            cgEmblemWin[1].Enable(isOn);
                            if (isOn)
                            {
                                tglClothesKind.isOn = false;
                                if ((bool)tglSailor01Kind)
                                {
                                    tglSailor01Kind.isOn = false;
                                }
                                if ((bool)tglSailor02Kind)
                                {
                                    tglSailor02Kind.isOn = false;
                                }
                                if ((bool)tglSailor03Kind)
                                {
                                    tglSailor03Kind.isOn = false;
                                }
                                if ((bool)tglJacket01Kind)
                                {
                                    tglJacket01Kind.isOn = false;
                                }
                                if ((bool)tglJacket02Kind)
                                {
                                    tglJacket02Kind.isOn = false;
                                }
                                if ((bool)tglJacket03Kind)
                                {
                                    tglJacket03Kind.isOn = false;
                                }
                                tglPtn01Kind.isOn = false;
                                tglPtn02Kind.isOn = false;
                                tglPtn03Kind.isOn = false;
                                if ((bool)tglPtn04Kind)
                                {
                                    tglPtn04Kind.isOn = false;
                                }
                                if ((bool)tglEmblemKind[0])
                                {
                                    tglEmblemKind[0].isOn = false;
                                }
                            }
                        }
                    }
                });
            }
            CvsColor.ConnectColorKind colorCos01Kind = CvsColor.ConnectColorKind.CosTop01;
            string winCos01Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosTop01;
                    winCos01Title = "トップスの色０１";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosBot01;
                    winCos01Title = "ボトムスの色０１";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosBra01;
                    winCos01Title = "ブラの色０１";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosShorts01;
                    winCos01Title = "ショーツの色０１";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosGloves01;
                    winCos01Title = "手袋の色０１";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosPanst01;
                    winCos01Title = "パンストの色０１";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosSocks01;
                    winCos01Title = "靴下の色０１";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosInnerShoes01;
                    winCos01Title = "内履きの色０１";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorCos01Kind = CvsColor.ConnectColorKind.CosOuterShoes01;
                    winCos01Title = "外履きの色０１";
                    break;
            }
            btnMainColor01.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorCos01Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winCos01Title, colorCos01Kind, clothes.parts[clothesType].colorInfo[0].baseColor, UpdateCosColor01, false);
                }
            });
            CvsColor.ConnectColorKind colorCos02Kind = CvsColor.ConnectColorKind.CosTop02;
            string winCos02Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosTop02;
                    winCos02Title = "トップスの色０２";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosBot02;
                    winCos02Title = "ボトムスの色０２";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosBra02;
                    winCos02Title = "ブラの色０２";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosShorts02;
                    winCos02Title = "ショーツの色０２";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosGloves02;
                    winCos02Title = "手袋の色０２";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosPanst02;
                    winCos02Title = "パンストの色０２";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosSocks02;
                    winCos02Title = "靴下の色０２";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosInnerShoes02;
                    winCos02Title = "内履きの色０２";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorCos02Kind = CvsColor.ConnectColorKind.CosOuterShoes02;
                    winCos02Title = "外履きの色０２";
                    break;
            }
            btnMainColor02.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorCos02Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winCos02Title, colorCos02Kind, clothes.parts[clothesType].colorInfo[1].baseColor, UpdateCosColor02, false);
                }
            });
            CvsColor.ConnectColorKind colorCos03Kind = CvsColor.ConnectColorKind.CosTop03;
            string winCos03Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosTop03;
                    winCos03Title = "トップスの色０３";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosBot03;
                    winCos03Title = "ボトムスの色０３";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosBra03;
                    winCos03Title = "ブラの色０３";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosShorts03;
                    winCos03Title = "ショーツの色０３";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosGloves03;
                    winCos03Title = "手袋の色０３";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosPanst03;
                    winCos03Title = "パンストの色０３";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosSocks03;
                    winCos03Title = "靴下の色０３";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosInnerShoes03;
                    winCos03Title = "内履きの色０３";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorCos03Kind = CvsColor.ConnectColorKind.CosOuterShoes03;
                    winCos03Title = "外履きの色０３";
                    break;
            }
            btnMainColor03.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorCos03Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winCos03Title, colorCos03Kind, clothes.parts[clothesType].colorInfo[2].baseColor, UpdateCosColor03, false);
                }
            });
            CvsColor.ConnectColorKind colorCos04Kind = CvsColor.ConnectColorKind.CosTop04;
            string winCos04Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosTop04;
                    winCos04Title = "トップスの色０４";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosBot04;
                    winCos04Title = "ボトムスの色０４";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosBra04;
                    winCos04Title = "ブラの色０４";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosShorts04;
                    winCos04Title = "ショーツの色０４";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosGloves04;
                    winCos04Title = "手袋の色０４";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosPanst04;
                    winCos04Title = "パンストの色０４";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosSocks04;
                    winCos04Title = "靴下の色０４";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosInnerShoes04;
                    winCos04Title = "内履きの色０４";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorCos04Kind = CvsColor.ConnectColorKind.CosOuterShoes04;
                    winCos04Title = "外履きの色０４";
                    break;
            }
            if ((bool)btnMainColor04)
            {
                btnMainColor04.OnClickAsObservable().Subscribe(delegate
                {
                    if (cvsColor.isOpen && cvsColor.connectColorKind == colorCos04Kind)
                    {
                        cvsColor.Close();
                    }
                    else
                    {
                        cvsColor.Setup(winCos04Title, colorCos04Kind, clothes.parts[clothesType].colorInfo[3].baseColor, UpdateCosColor04, false);
                    }
                });
            }
            CvsColor.ConnectColorKind colorPtn01Kind = CvsColor.ConnectColorKind.CosTopPtn01;
            string winPtn01Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosTopPtn01;
                    winPtn01Title = "トップス柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosBotPtn01;
                    winPtn01Title = "ボトムス柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosBraPtn01;
                    winPtn01Title = "ブラ柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosShortsPtn01;
                    winPtn01Title = "ショーツ柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosGlovesPtn01;
                    winPtn01Title = "手袋柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosPanstPtn01;
                    winPtn01Title = "パンスト柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosSocksPtn01;
                    winPtn01Title = "靴下柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosInnerShoesPtn01;
                    winPtn01Title = "内履き柄の色０１";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorPtn01Kind = CvsColor.ConnectColorKind.CosOuterShoesPtn01;
                    winPtn01Title = "外履き柄の色０１";
                    break;
            }
            btnPtnColor01.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorPtn01Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winPtn01Title, colorPtn01Kind, clothes.parts[clothesType].colorInfo[0].patternColor, UpdatePtnColor01, true);
                }
            });
            CvsColor.ConnectColorKind colorPtn02Kind = CvsColor.ConnectColorKind.CosTopPtn02;
            string winPtn02Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosTopPtn02;
                    winPtn02Title = "トップス柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosBotPtn02;
                    winPtn02Title = "ボトムス柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosBraPtn02;
                    winPtn02Title = "ブラ柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosShortsPtn02;
                    winPtn02Title = "ショーツ柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosGlovesPtn02;
                    winPtn02Title = "手袋柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosPanstPtn02;
                    winPtn02Title = "パンスト柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosSocksPtn02;
                    winPtn02Title = "靴下柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosInnerShoesPtn02;
                    winPtn02Title = "内履き柄の色０２";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorPtn02Kind = CvsColor.ConnectColorKind.CosOuterShoesPtn02;
                    winPtn02Title = "外履き柄の色０２";
                    break;
            }
            btnPtnColor02.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorPtn02Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winPtn02Title, colorPtn02Kind, clothes.parts[clothesType].colorInfo[1].patternColor, UpdatePtnColor02, true);
                }
            });
            CvsColor.ConnectColorKind colorPtn03Kind = CvsColor.ConnectColorKind.CosTopPtn03;
            string winPtn03Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosTopPtn03;
                    winPtn03Title = "トップス柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosBotPtn03;
                    winPtn03Title = "ボトムス柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosBraPtn03;
                    winPtn03Title = "ブラ柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosShortsPtn03;
                    winPtn03Title = "ショーツ柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosGlovesPtn03;
                    winPtn03Title = "手袋柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosPanstPtn03;
                    winPtn03Title = "パンスト柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosSocksPtn03;
                    winPtn03Title = "靴下柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosInnerShoesPtn03;
                    winPtn03Title = "内履き柄の色０３";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorPtn03Kind = CvsColor.ConnectColorKind.CosOuterShoesPtn03;
                    winPtn03Title = "外履き柄の色０３";
                    break;
            }
            btnPtnColor03.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == colorPtn03Kind)
                {
                    cvsColor.Close();
                }
                else
                {
                    cvsColor.Setup(winPtn03Title, colorPtn03Kind, clothes.parts[clothesType].colorInfo[2].patternColor, UpdatePtnColor03, true);
                }
            });
            CvsColor.ConnectColorKind colorPtn04Kind = CvsColor.ConnectColorKind.CosTopPtn04;
            string winPtn04Title = string.Empty;
            switch (typeClothes)
            {
                case ChaFileDefine.ClothesKind.top:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosTopPtn04;
                    winPtn04Title = "トップス柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.bot:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosBotPtn04;
                    winPtn04Title = "ボトムス柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.bra:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosBraPtn04;
                    winPtn04Title = "ブラ柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.shorts:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosShortsPtn04;
                    winPtn04Title = "ショーツ柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.gloves:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosGlovesPtn04;
                    winPtn04Title = "手袋柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.panst:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosPanstPtn04;
                    winPtn04Title = "パンスト柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.socks:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosSocksPtn04;
                    winPtn04Title = "靴下柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.shoes_inner:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosInnerShoesPtn04;
                    winPtn04Title = "内履き柄の色０４";
                    break;
                case ChaFileDefine.ClothesKind.shoes_outer:
                    colorPtn04Kind = CvsColor.ConnectColorKind.CosOuterShoesPtn04;
                    winPtn04Title = "外履き柄の色０４";
                    break;
            }
            if ((bool)btnPtnColor04)
            {
                btnPtnColor04.OnClickAsObservable().Subscribe(delegate
                {
                    if (cvsColor.isOpen && cvsColor.connectColorKind == colorPtn04Kind)
                    {
                        cvsColor.Close();
                    }
                    else
                    {
                        cvsColor.Setup(winPtn04Title, colorPtn04Kind, clothes.parts[clothesType].colorInfo[3].patternColor, UpdatePtnColor04, true);
                    }
                });
            }
            sldPtn01Width.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj31 = clothes.parts[clothesType].colorInfo[0];
                Vector2 tiling39 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj31.tiling = new Vector2(value, tiling39.y);
                ChaFileClothes.PartsInfo.ColorInfo obj32 = setClothes.parts[clothesType].colorInfo[0];
                Vector2 tiling40 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj32.tiling = new Vector2(value, tiling40.y);
                FuncUpdateCosColor();
                inpPtn01Width.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn01Width.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider8 = sldPtn01Width;
                float value9 = sldPtn01Width.value;
                Vector2 scrollDelta8 = scl.scrollDelta;
                slider8.value = Mathf.Clamp(value9 + scrollDelta8.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn01Width.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn01Width.value);
            });
            inpPtn01Width.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn01Width.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn01Width.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling36 = defClothes.parts[clothesType].colorInfo[0].tiling;
                float x4 = tiling36.x;
                ChaFileClothes.PartsInfo.ColorInfo obj29 = clothes.parts[clothesType].colorInfo[0];
                Vector2 tiling37 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj29.tiling = new Vector2(x4, tiling37.y);
                ChaFileClothes.PartsInfo.ColorInfo obj30 = setClothes.parts[clothesType].colorInfo[0];
                Vector2 tiling38 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj30.tiling = new Vector2(x4, tiling38.y);
                inpPtn01Width.text = CustomBase.ConvertTextFromRate(0, 100, x4);
                sldPtn01Width.value = x4;
                FuncUpdateCosColor();
            });
            sldPtn01Height.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj27 = clothes.parts[clothesType].colorInfo[0];
                Vector2 tiling34 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj27.tiling = new Vector2(tiling34.x, value);
                ChaFileClothes.PartsInfo.ColorInfo obj28 = setClothes.parts[clothesType].colorInfo[0];
                Vector2 tiling35 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj28.tiling = new Vector2(tiling35.x, value);
                FuncUpdateCosColor();
                inpPtn01Height.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn01Height.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider7 = sldPtn01Height;
                float value8 = sldPtn01Height.value;
                Vector2 scrollDelta7 = scl.scrollDelta;
                slider7.value = Mathf.Clamp(value8 + scrollDelta7.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn01Height.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn01Height.value);
            });
            inpPtn01Height.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn01Height.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn01Height.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling31 = defClothes.parts[clothesType].colorInfo[0].tiling;
                float y4 = tiling31.y;
                ChaFileClothes.PartsInfo.ColorInfo obj25 = clothes.parts[clothesType].colorInfo[0];
                Vector2 tiling32 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj25.tiling = new Vector2(tiling32.x, y4);
                ChaFileClothes.PartsInfo.ColorInfo obj26 = setClothes.parts[clothesType].colorInfo[0];
                Vector2 tiling33 = clothes.parts[clothesType].colorInfo[0].tiling;
                obj26.tiling = new Vector2(tiling33.x, y4);
                inpPtn01Height.text = CustomBase.ConvertTextFromRate(0, 100, y4);
                sldPtn01Height.value = y4;
                FuncUpdateCosColor();
            });
            sldPtn02Width.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj23 = clothes.parts[clothesType].colorInfo[1];
                Vector2 tiling29 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj23.tiling = new Vector2(value, tiling29.y);
                ChaFileClothes.PartsInfo.ColorInfo obj24 = setClothes.parts[clothesType].colorInfo[1];
                Vector2 tiling30 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj24.tiling = new Vector2(value, tiling30.y);
                FuncUpdateCosColor();
                inpPtn02Width.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn02Width.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider6 = sldPtn02Width;
                float value7 = sldPtn02Width.value;
                Vector2 scrollDelta6 = scl.scrollDelta;
                slider6.value = Mathf.Clamp(value7 + scrollDelta6.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn02Width.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn02Width.value);
            });
            inpPtn02Width.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn02Width.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn02Width.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling26 = defClothes.parts[clothesType].colorInfo[1].tiling;
                float x3 = tiling26.x;
                ChaFileClothes.PartsInfo.ColorInfo obj21 = clothes.parts[clothesType].colorInfo[1];
                Vector2 tiling27 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj21.tiling = new Vector2(x3, tiling27.y);
                ChaFileClothes.PartsInfo.ColorInfo obj22 = setClothes.parts[clothesType].colorInfo[1];
                Vector2 tiling28 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj22.tiling = new Vector2(x3, tiling28.y);
                inpPtn02Width.text = CustomBase.ConvertTextFromRate(0, 100, x3);
                sldPtn02Width.value = x3;
                FuncUpdateCosColor();
            });
            sldPtn02Height.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj19 = clothes.parts[clothesType].colorInfo[1];
                Vector2 tiling24 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj19.tiling = new Vector2(tiling24.x, value);
                ChaFileClothes.PartsInfo.ColorInfo obj20 = setClothes.parts[clothesType].colorInfo[1];
                Vector2 tiling25 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj20.tiling = new Vector2(tiling25.x, value);
                FuncUpdateCosColor();
                inpPtn02Height.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn02Height.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider5 = sldPtn02Height;
                float value6 = sldPtn02Height.value;
                Vector2 scrollDelta5 = scl.scrollDelta;
                slider5.value = Mathf.Clamp(value6 + scrollDelta5.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn02Height.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn02Height.value);
            });
            inpPtn02Height.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn02Height.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn02Height.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling21 = defClothes.parts[clothesType].colorInfo[1].tiling;
                float y3 = tiling21.y;
                ChaFileClothes.PartsInfo.ColorInfo obj17 = clothes.parts[clothesType].colorInfo[1];
                Vector2 tiling22 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj17.tiling = new Vector2(tiling22.x, y3);
                ChaFileClothes.PartsInfo.ColorInfo obj18 = setClothes.parts[clothesType].colorInfo[1];
                Vector2 tiling23 = clothes.parts[clothesType].colorInfo[1].tiling;
                obj18.tiling = new Vector2(tiling23.x, y3);
                inpPtn02Height.text = CustomBase.ConvertTextFromRate(0, 100, y3);
                sldPtn02Height.value = y3;
                FuncUpdateCosColor();
            });
            sldPtn03Width.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj15 = clothes.parts[clothesType].colorInfo[2];
                Vector2 tiling19 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj15.tiling = new Vector2(value, tiling19.y);
                ChaFileClothes.PartsInfo.ColorInfo obj16 = setClothes.parts[clothesType].colorInfo[2];
                Vector2 tiling20 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj16.tiling = new Vector2(value, tiling20.y);
                FuncUpdateCosColor();
                inpPtn03Width.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn03Width.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider4 = sldPtn03Width;
                float value5 = sldPtn03Width.value;
                Vector2 scrollDelta4 = scl.scrollDelta;
                slider4.value = Mathf.Clamp(value5 + scrollDelta4.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn03Width.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn03Width.value);
            });
            inpPtn03Width.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn03Width.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn03Width.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling16 = defClothes.parts[clothesType].colorInfo[2].tiling;
                float x2 = tiling16.x;
                ChaFileClothes.PartsInfo.ColorInfo obj13 = clothes.parts[clothesType].colorInfo[2];
                Vector2 tiling17 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj13.tiling = new Vector2(x2, tiling17.y);
                ChaFileClothes.PartsInfo.ColorInfo obj14 = setClothes.parts[clothesType].colorInfo[2];
                Vector2 tiling18 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj14.tiling = new Vector2(x2, tiling18.y);
                inpPtn03Width.text = CustomBase.ConvertTextFromRate(0, 100, x2);
                sldPtn03Width.value = x2;
                FuncUpdateCosColor();
            });
            sldPtn03Height.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                ChaFileClothes.PartsInfo.ColorInfo obj11 = clothes.parts[clothesType].colorInfo[2];
                Vector2 tiling14 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj11.tiling = new Vector2(tiling14.x, value);
                ChaFileClothes.PartsInfo.ColorInfo obj12 = setClothes.parts[clothesType].colorInfo[2];
                Vector2 tiling15 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj12.tiling = new Vector2(tiling15.x, value);
                FuncUpdateCosColor();
                inpPtn03Height.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldPtn03Height.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider3 = sldPtn03Height;
                float value4 = sldPtn03Height.value;
                Vector2 scrollDelta3 = scl.scrollDelta;
                slider3.value = Mathf.Clamp(value4 + scrollDelta3.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpPtn03Height.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn03Height.value);
            });
            inpPtn03Height.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldPtn03Height.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnPtn03Height.onClick.AsObservable().Subscribe(delegate
            {
                Vector2 tiling11 = defClothes.parts[clothesType].colorInfo[2].tiling;
                float y2 = tiling11.y;
                ChaFileClothes.PartsInfo.ColorInfo obj9 = clothes.parts[clothesType].colorInfo[2];
                Vector2 tiling12 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj9.tiling = new Vector2(tiling12.x, y2);
                ChaFileClothes.PartsInfo.ColorInfo obj10 = setClothes.parts[clothesType].colorInfo[2];
                Vector2 tiling13 = clothes.parts[clothesType].colorInfo[2].tiling;
                obj10.tiling = new Vector2(tiling13.x, y2);
                inpPtn03Height.text = CustomBase.ConvertTextFromRate(0, 100, y2);
                sldPtn03Height.value = y2;
                FuncUpdateCosColor();
            });
            if ((bool)sldPtn04Width)
            {
                sldPtn04Width.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    ChaFileClothes.PartsInfo.ColorInfo obj7 = clothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling9 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj7.tiling = new Vector2(value, tiling9.y);
                    ChaFileClothes.PartsInfo.ColorInfo obj8 = setClothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling10 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj8.tiling = new Vector2(value, tiling10.y);
                    FuncUpdateCosColor();
                    inpPtn04Width.text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
            }
            if ((bool)sldPtn04Width)
            {
                sldPtn04Width.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider2 = sldPtn04Width;
                    float value3 = sldPtn04Width.value;
                    Vector2 scrollDelta2 = scl.scrollDelta;
                    slider2.value = Mathf.Clamp(value3 + scrollDelta2.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    inpPtn04Width.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn04Width.value);
                });
            }
            if ((bool)inpPtn04Width)
            {
                inpPtn04Width.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    sldPtn04Width.value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            }
            if ((bool)btnPtn04Width)
            {
                btnPtn04Width.onClick.AsObservable().Subscribe(delegate
                {
                    Vector2 tiling6 = defClothes.parts[clothesType].colorInfo[3].tiling;
                    float x = tiling6.x;
                    ChaFileClothes.PartsInfo.ColorInfo obj5 = clothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling7 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj5.tiling = new Vector2(x, tiling7.y);
                    ChaFileClothes.PartsInfo.ColorInfo obj6 = setClothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling8 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj6.tiling = new Vector2(x, tiling8.y);
                    inpPtn04Width.text = CustomBase.ConvertTextFromRate(0, 100, x);
                    sldPtn04Width.value = x;
                    FuncUpdateCosColor();
                });
            }
            if ((bool)sldPtn04Height)
            {
                sldPtn04Height.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    ChaFileClothes.PartsInfo.ColorInfo obj3 = clothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling4 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj3.tiling = new Vector2(tiling4.x, value);
                    ChaFileClothes.PartsInfo.ColorInfo obj4 = setClothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling5 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj4.tiling = new Vector2(tiling5.x, value);
                    FuncUpdateCosColor();
                    inpPtn04Height.text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
            }
            if ((bool)sldPtn04Height)
            {
                sldPtn04Height.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider = sldPtn04Height;
                    float value2 = sldPtn04Height.value;
                    Vector2 scrollDelta = scl.scrollDelta;
                    slider.value = Mathf.Clamp(value2 + scrollDelta.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    inpPtn04Height.text = CustomBase.ConvertTextFromRate(0, 100, sldPtn04Height.value);
                });
            }
            if ((bool)inpPtn04Height)
            {
                inpPtn04Height.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    sldPtn04Height.value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            }
            if ((bool)btnPtn04Height)
            {
                btnPtn04Height.onClick.AsObservable().Subscribe(delegate
                {
                    Vector2 tiling = defClothes.parts[clothesType].colorInfo[3].tiling;
                    float y = tiling.y;
                    ChaFileClothes.PartsInfo.ColorInfo obj = clothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling2 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj.tiling = new Vector2(tiling2.x, y);
                    ChaFileClothes.PartsInfo.ColorInfo obj2 = setClothes.parts[clothesType].colorInfo[3];
                    Vector2 tiling3 = clothes.parts[clothesType].colorInfo[3].tiling;
                    obj2.tiling = new Vector2(tiling3.x, y);
                    inpPtn04Height.text = CustomBase.ConvertTextFromRate(0, 100, y);
                    sldPtn04Height.value = y;
                    FuncUpdateCosColor();
                });
            }
            btnInitSetting.OnClickAsObservable().Subscribe(delegate
            {
                for (int i = 0; i < 4; i++)
                {
                    Color clothesDefaultColor = chaCtrl.GetClothesDefaultColor(clothesType, i);
                    clothes.parts[clothesType].colorInfo[i].baseColor = clothesDefaultColor;
                    setClothes.parts[clothesType].colorInfo[i].baseColor = clothesDefaultColor;
                    clothes.parts[clothesType].colorInfo[i].patternColor = Color.white;
                    setClothes.parts[clothesType].colorInfo[i].patternColor = Color.white;
                    clothes.parts[clothesType].colorInfo[i].pattern = 0;
                    setClothes.parts[clothesType].colorInfo[i].pattern = 0;
                    clothes.parts[clothesType].colorInfo[i].tiling = Vector2.zero;
                    setClothes.parts[clothesType].colorInfo[i].tiling = Vector2.zero;
                }
                FuncUpdateAllPtnAndColor();
                UpdateCustomUI();
            });
            tglOption.Select((val, idx) => new
            {
                val,
                idx
            }).ToList().ForEach(item =>
            {
                item.val.onValueChanged.AddListener(delegate (bool isOn)
                {
                    if (clothesType == 2)
                    {
                        clothes.hideBraOpt[item.idx] = !isOn;
                        setClothes.hideBraOpt[item.idx] = !isOn;
                    }
                    else if (clothesType == 3)
                    {
                        clothes.hideShortsOpt[item.idx] = !isOn;
                        setClothes.hideShortsOpt[item.idx] = !isOn;
                    }
                    else
                    {
                        clothes.parts[clothesType].hideOpt[item.idx] = !isOn;
                        setClothes.parts[clothesType].hideOpt[item.idx] = !isOn;
                    }
                });
            });
            if (tglSleevesType.Any())
            {
                tglSleevesType.Select((val, idx) => new
                {
                    val,
                    idx
                }).ToList().ForEach(item =>
                {
                    item.val.onValueChanged.AddListener(delegate (bool isOn)
                    {
                        if (!Singleton<CustomBase>.Instance.updateCustomUI && isOn)
                        {
                            clothes.parts[clothesType].sleevesType = item.idx;
                            setClothes.parts[clothesType].sleevesType = item.idx;
                        }
                    });
                });
            }
            StartCoroutine(SetInputText());
        }
    }
}
