using Illusion.CustomAttributes;
using System.IO;
using System.Text;
using UnityEngine;

public class CreateURL : MonoBehaviour
{
    public string KK_Check_URL = string.Empty;

    [Button("CreateKK_Check_URL", "KK_Check_URL作成", new object[]
    {

    })]
    public int excuteCreateKK_Check_URL;

    public string KK_Cha_URL = string.Empty;

    [Button("CreateKK_Cha_URL", "KK_Cha_URL作成", new object[]
    {

    })]
    public int excuteCreateKK_Cha_URL;

    public string KK_Ranking_URL = string.Empty;

    [Button("CreateKK_Ranking_URL", "KK_Ranking_URL作成", new object[]
    {

    })]
    public int excuteCreateKK_Ranking_URL;

    public static string Load_KK_Check_URL()
    {
        return LoadURL("kk_check_url.dat");
    }

    public static string Load_KK_Cha_URL()
    {
        return LoadURL("kk_cha_url.dat");
    }

    public static string Load_KK_Ranking_URL()
    {
        return LoadURL("kk_ranking_url.dat");
    }

    public void CreateKK_Check_URL()
    {
        byte[] bytes = Encoding.UTF8.GetBytes(KK_Check_URL);
        byte[] buffer = YS_Assist.EncryptAES(bytes, "koikatu", "phpaddress");
        string path = UserData.Path + "/url/kk_check_url.dat";
        string directoryName = Path.GetDirectoryName(path);
        if (!Directory.Exists(directoryName))
        {
            Directory.CreateDirectory(directoryName);
        }
        using (FileStream output = new FileStream(path, FileMode.Create, FileAccess.Write))
        {
            using (BinaryWriter binaryWriter = new BinaryWriter(output))
            {
                binaryWriter.Write(buffer);
            }
        }
    }

    public void CreateKK_Cha_URL()
    {
        byte[] bytes = Encoding.UTF8.GetBytes(KK_Cha_URL);
        byte[] buffer = YS_Assist.EncryptAES(bytes, "koikatu", "phpaddress");
        string path = UserData.Path + "/url/kk_cha_url.dat";
        string directoryName = Path.GetDirectoryName(path);
        if (!Directory.Exists(directoryName))
        {
            Directory.CreateDirectory(directoryName);
        }
        using (FileStream output = new FileStream(path, FileMode.Create, FileAccess.Write))
        {
            using (BinaryWriter binaryWriter = new BinaryWriter(output))
            {
                binaryWriter.Write(buffer);
            }
        }
    }

    public void CreateKK_Ranking_URL()
    {
        byte[] bytes = Encoding.UTF8.GetBytes(KK_Ranking_URL);
        byte[] buffer = YS_Assist.EncryptAES(bytes, "koikatu", "phpaddress");
        string path = UserData.Path + "/url/kk_ranking_url.dat";
        string directoryName = Path.GetDirectoryName(path);
        if (!Directory.Exists(directoryName))
        {
            Directory.CreateDirectory(directoryName);
        }
        using (FileStream output = new FileStream(path, FileMode.Create, FileAccess.Write))
        {
            using (BinaryWriter binaryWriter = new BinaryWriter(output))
            {
                binaryWriter.Write(buffer);
            }
        }
    }

    public static string LoadURL(string urlFile)
    {
        byte[] array = null;
        string path = UserData.Path + "/url/" + urlFile;
        if (!File.Exists(path))
        {
            return string.Empty;
        }
        using (FileStream fileStream = new FileStream(path, FileMode.Open, FileAccess.Read))
        {
            using (BinaryReader binaryReader = new BinaryReader(fileStream))
            {
                array = binaryReader.ReadBytes((int)fileStream.Length);
            }
        }
        if (array == null)
        {
            return string.Empty;
        }
        byte[] bytes = YS_Assist.DecryptAES(array, "koikatu", "phpaddress");
        return Encoding.UTF8.GetString(bytes);
    }
}
