using UnityEngine;
using UnityEngine.EventSystems;

public class EventSystemMessage : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler, IPointerDownHandler, IPointerUpHandler, IPointerClickHandler, IInitializePotentialDragHandler, IBeginDragHandler, IDragHandler, IEndDragHandler, IDropHandler, IScrollHandler, IUpdateSelectedHandler, ISelectHandler, IDeselectHandler, IMoveHandler, ISubmitHandler, ICancelHandler, IEventSystemHandler
{
    private bool _UpdateSelected;

    public void OnPointerEnter(PointerEventData eventData)
    {
        print("OnPointerEnter : " + eventData);
    }

    public void OnPointerExit(PointerEventData eventData)
    {
        print("OnPointerExit : " + eventData);
    }

    public void OnPointerDown(PointerEventData eventData)
    {
        print("OnPointerDown : " + eventData);
    }

    public void OnPointerUp(PointerEventData eventData)
    {
        print("OnPointerUp : " + eventData);
    }

    public void OnPointerClick(PointerEventData eventData)
    {
        print("OnPointerClick : " + eventData);
    }

    public void OnInitializePotentialDrag(PointerEventData eventData)
    {
        print("OnInitializePotentialDrag : " + eventData);
    }

    public void OnBeginDrag(PointerEventData eventData)
    {
        print("OnBeginDrag : " + eventData);
    }

    public void OnDrag(PointerEventData eventData)
    {
        print("OnDrag : " + eventData);
    }

    public void OnEndDrag(PointerEventData eventData)
    {
        print("OnEndDrag : " + eventData);
    }

    public void OnDrop(PointerEventData eventData)
    {
        print("OnDrop : " + eventData);
    }

    public void OnScroll(PointerEventData eventData)
    {
        print("OnScroll : " + eventData);
    }

    public void OnUpdateSelected(BaseEventData eventData)
    {
        if (!_UpdateSelected)
        {
            print("OnUpdateSelected : " + eventData);
            _UpdateSelected = true;
        }
    }

    public void OnSelect(BaseEventData eventData)
    {
        print("OnSelect : " + eventData);
        _UpdateSelected = false;
    }

    public void OnDeselect(BaseEventData eventData)
    {
        print("OnDeselect : " + eventData);
    }

    public void OnMove(AxisEventData eventData)
    {
        print("OnMove : " + eventData);
    }

    public void OnSubmit(BaseEventData eventData)
    {
        print("OnSubmit : " + eventData);
    }

    public void OnCancel(BaseEventData eventData)
    {
        print("OnCancel : " + eventData);
    }
}
