using UnityEngine;

namespace IllusionUtility.SetUtility
{
    public static class SpriteRenderColorEx
    {
        public static void SetColorR(this SpriteRenderer sr, float r)
        {
            Color color = sr.color;
            float g = color.g;
            Color color2 = sr.color;
            float b = color2.b;
            Color color3 = sr.color;
            Color color4 = new Color(r, g, b, color3.a);
            sr.color = color4;
        }

        public static void SetColorG(this SpriteRenderer sr, float g)
        {
            Color color = sr.color;
            float r = color.r;
            Color color2 = sr.color;
            float b = color2.b;
            Color color3 = sr.color;
            Color color4 = new Color(r, g, b, color3.a);
            sr.color = color4;
        }

        public static void SetColorB(this SpriteRenderer sr, float b)
        {
            Color color = sr.color;
            float r = color.r;
            Color color2 = sr.color;
            float g = color2.g;
            Color color3 = sr.color;
            Color color4 = new Color(r, g, b, color3.a);
            sr.color = color4;
        }

        public static void SetColorA(this SpriteRenderer sr, float a)
        {
            Color color = sr.color;
            float r = color.r;
            Color color2 = sr.color;
            float g = color2.g;
            Color color3 = sr.color;
            Color color4 = new Color(r, g, color3.b, a);
            sr.color = color4;
        }
    }
}
