using System;
using UnityEngine;

[Serializable]
public class MatAnmSimpleInfo
{
    public YS_Timer yst;

    public MeshRenderer mr;

    public int materialNo;

    public float time;

    public bool change_RGB = true;

    public bool change_A = true;

    public Gradient Value;

    private float cnt;

    public void Update(int colorPropertyId)
    {
        if (null == mr)
        {
            return;
        }
        float num;
        if (null == yst)
        {
            cnt += Time.deltaTime;
            while (time < cnt)
            {
                cnt -= time;
            }
            num = cnt / time;
        }
        else
        {
            num = yst.rate;
        }
        Color color = mr.material.GetColor(colorPropertyId);
        if (change_RGB)
        {
            Color color2 = Value.Evaluate(num);
            color.r = color2.r;
            Color color3 = Value.Evaluate(num);
            color.g = color3.g;
            Color color4 = Value.Evaluate(num);
            color.b = color4.b;
        }
        if (change_A)
        {
            Color color5 = Value.Evaluate(num);
            color.a = color5.a;
        }
        mr.material.SetColor(colorPropertyId, color);
    }
}
