using UnityEngine;

public class MayaCameraConverter : MonoBehaviour
{
    private Camera[] _camera;

    private void Awake()
    {
        _camera = GetComponentsInChildren<Camera>();
    }

    private void LateUpdate()
    {
        Camera[] camera = _camera;
        foreach (Camera camera2 in camera)
        {
            Vector3 localScale = transform.localScale;
            camera2.nearClipPlane = localScale.x;
            Vector3 localScale2 = transform.localScale;
            camera2.farClipPlane = localScale2.y;
            Vector3 localScale3 = transform.localScale;
            camera2.fieldOfView = localScale3.z;
        }
    }
}
