using UnityEngine;

public class MonoBehaviourMessage : MonoBehaviour
{
    public void Awake()
    {
        print("Awake : " + name);
    }

    public void Start()
    {
        print("Start : " + name);
    }

    public void OnEnable()
    {
        print("OnEnable : " + name);
    }

    public void OnDisable()
    {
        print("OnDisable : " + name);
    }

    public void OnDestroy()
    {
        print("OnDestroy : " + name);
    }

    public void OnApplicationFocus(bool isFocus)
    {
        print("OnApplicationFocus : " + name);
        print("isFocus : " + isFocus);
    }

    public void OnApplicationPause(bool isPause)
    {
        print("OnApplicationPause : " + name);
        print("isPause : " + isPause);
    }

    public void OnApplicationQuit()
    {
        print("OnApplicationQuit : " + name);
    }

    public void OnTransformChildrenChanged()
    {
        print("OnTransformChildrenChanged : " + name);
    }

    public void OnTransformParentChanged()
    {
        print("OnTransformParentChanged : " + name);
    }

    public void OnValidate()
    {
        print("OnValidate : " + name);
    }

    public void Reset()
    {
        print("Reset : " + name);
    }

    public void OnAnimatorIK()
    {
        print("OnAnimatorIK : " + name);
    }

    public void OnAnimatorMove()
    {
        print("OnAnimatorMove : " + name);
    }

    public void OnAudioFilterRead(float[] data, int channels)
    {
        print("OnAudioFilterRead : " + name);
    }

    public void OnJointBreak()
    {
        print("OnJointBreak : " + name);
    }

    public void OnParticleCollision()
    {
        print("OnParticleCollision : " + name);
    }

    public void FixedUpdate()
    {
        print("FixedUpdate : " + name);
    }

    public void Update()
    {
        print("Update : " + name);
    }

    public void LateUpdate()
    {
        print("LateUpdate : " + name);
    }

    public void OnConnectedToServer()
    {
        print("OnConnectedToServer : " + name);
    }

    public void OnDisconnectedFromServer()
    {
        print("OnDisconnectedFromServer : " + name);
    }

    public void OnFailedToConnect()
    {
        print("OnFailedToConnect : " + name);
    }

    public void OnFailedToConnectToMasterServer()
    {
        print("OnFailedToConnectToMasterServer : " + name);
    }

    public void OnMasterServerEvent()
    {
        print("OnMasterServerEvent : " + name);
    }

    public void OnNetworkInstantiate(NetworkMessageInfo info)
    {
        print("OnNetworkInstantiate : " + name);
        print("NetworkMessageInfo : " + info);
    }

    public void OnPlayerConnected()
    {
        print("OnPlayerConnected : " + name);
    }

    public void OnPlayerDisconnected()
    {
        print("OnPlayerDisconnected : " + name);
    }

    public void OnSerializeNetworkView(BitStream stream, NetworkMessageInfo info)
    {
        print("OnSerializeNetworkView : " + name);
        print("BitStream : " + stream);
        print("NetworkMessageInfo : " + info);
    }

    public void OnServerInitialized()
    {
        print("OnServerInitialized : " + name);
    }

    public void OnMouseDown()
    {
        print("OnMouseDown : " + name);
    }

    public void OnMouseUp()
    {
        print("OnMouseUp : " + name);
    }

    public void OnMouseUpAsButton()
    {
        print("OnMouseUpAsButton : " + name);
    }

    public void OnMouseDrag()
    {
        print("OnMouseDrag : " + name);
    }

    public void OnMouseEnter()
    {
        print("OnMouseEnter : " + name);
    }

    public void OnMouseExit()
    {
        print("OnMouseExit : " + name);
    }

    public void OnMouseOver()
    {
        print("OnMouseOver : " + name);
    }

    public void OnControllerColliderHit(ControllerColliderHit hit)
    {
        print("OnControllerColliderHit : " + hit);
    }

    public void OnTriggerEnter(Collider col)
    {
        print("OnTriggerEnter : " + col);
    }

    public void OnTriggerExit(Collider col)
    {
        print("OnTriggerExit : " + col);
    }

    public void OnTriggerStay(Collider col)
    {
        print("OnTriggerStay : " + col);
    }

    public void OnCollisionEnter(Collision col)
    {
        print("OnCollisionEnter : " + col.gameObject);
    }

    public void OnCollisionExit(Collision col)
    {
        print("OnCollisionExit : " + col.gameObject);
    }

    public void OnCollisionStay(Collision col)
    {
        print("OnCollisionStay : " + col.gameObject);
    }

    public void OnTriggerEnter2D(Collider2D col)
    {
        print("OnTriggerEnter2D : " + col);
    }

    public void OnTriggerExit2D(Collider2D col)
    {
        print("OnTriggerExit2D : " + col);
    }

    public void OnTriggerStay2D(Collider2D col)
    {
        print("OnTriggerStay2D : " + col);
    }

    public void OnCollisionEnter2D(Collision2D col)
    {
        print("OnCollisionEnter2D : " + col.gameObject);
    }

    public void OnCollisionExit2D(Collision2D col)
    {
        print("OnCollisionExit2D : " + col.gameObject);
    }

    public void OnCollisionStay2D(Collision2D col)
    {
        print("OnCollisionStay2D : " + col.gameObject);
    }

    public void OnPreCull()
    {
        print("OnPreCull : " + name);
    }

    public void OnBecameVisible()
    {
        print("OnBecameVisible : " + name);
    }

    public void OnBecameInvisible()
    {
        print("OnBecameInvisible : " + name);
    }

    public void OnWillRenderObject()
    {
        print("OnWillRenderObject : " + name);
    }

    public void OnPreRender()
    {
        print("OnPreRender : " + name);
    }

    public void OnRenderObject()
    {
        print("OnRenderObject : " + name);
    }

    public void OnPostRender()
    {
        print("OnPostRender : " + name);
    }

    public void OnRenderImage(RenderTexture src, RenderTexture dest)
    {
        print("OnRenderImage : " + name);
        print("src : " + src);
        print("dest : " + dest);
    }

    public void OnGUI()
    {
        print("OnGUI : " + name);
    }

    public void OnDrawGizmos()
    {
        print("OnDrawGizmos : " + name);
    }

    public void OnDrawGizmosSelected()
    {
        print("OnDrawGizmosSelected : " + name);
    }
}
