using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections;

namespace NodeCanvas.Tasks.Actions
{
    [Category("✫ Blackboard/Lists")]
    public class GetListCount : ActionTask
    {
        [BlackboardOnly]
        [RequiredField]
        public BBParameter<IList> targetList;

        [BlackboardOnly]
        public BBParameter<int> saveAs;

        protected override string info
        {
            get
            {
                return string.Format("{0} = {0}.Count", saveAs, targetList);
            }
        }

        protected override void OnExecute()
        {
            saveAs.value = targetList.value.Count;
            EndAction(true);
        }
    }
}
