using UnityEngine;

public class ReCalculateNormals : MonoBehaviour
{
    public void Update()
    {
        MeshFilter meshFilter = new MeshFilter();
        meshFilter = gameObject.GetComponent(typeof(MeshFilter)) as MeshFilter;
        Mesh mesh;
        if ((bool)meshFilter)
        {
            mesh = meshFilter.sharedMesh;
        }
        else
        {
            SkinnedMeshRenderer skinnedMeshRenderer = new SkinnedMeshRenderer();
            skinnedMeshRenderer = gameObject.GetComponent(typeof(SkinnedMeshRenderer)) as SkinnedMeshRenderer;
            mesh = skinnedMeshRenderer.sharedMesh;
        }
        if (null != mesh)
        {
            mesh.RecalculateNormals();
        }
    }
}
