using UnityEngine;

public class SpriteInfo
{
    public static Vector2 GetPivotInSprite(Sprite sprite)
    {
        Vector2 result = default(Vector2);
        if (null != sprite)
        {
            Vector3 size = sprite.bounds.size;
            if (size.x != 0f)
            {
                Vector3 center = sprite.bounds.center;
                float x = center.x;
                Vector3 size2 = sprite.bounds.size;
                result.x = 0.5f - x / size2.x;
            }
            Vector3 size3 = sprite.bounds.size;
            if (size3.y != 0f)
            {
                Vector3 center2 = sprite.bounds.center;
                float y = center2.y;
                Vector3 size4 = sprite.bounds.size;
                result.y = 0.5f - y / size4.y;
            }
        }
        return result;
    }
}
