using Illusion.Game;
using StaffRoom;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class StaffRoomMapFile : MonoBehaviour
{
    [SerializeField]
    private StaffRoomMenuScene staffroomoscene;

    [SerializeField]
    private StaffRoomMapListCtrl listCtrl;

    private void Start()
    {
        List<MapInfo.Param> list = staffroomoscene.baseMap.infoDic.Values.Where(m => m.isGate).ToList();
        listCtrl.ClearList();
        int count = list.Count;
        int num = 0;
        Dictionary<int, MapInfo.Param> chaFileDic = new Dictionary<int, MapInfo.Param>();
        for (int i = 0; i < count; i++)
        {
            listCtrl.AddList(num, list[i].ThumbnailBundle, list[i].ThumbnailAsset);
            chaFileDic.Add(num, list[i]);
            num++;
        }
        listCtrl.OnPointerClick += delegate (MapFileInfo info)
        {
            staffroomoscene.SetMapInfo(info != null ? chaFileDic[info.index] : null);
            Utils.Sound.Play(SystemSE.sel);
        };
        listCtrl.Create(delegate
        {
        });
    }
}
